Package: satuRn
Type: Package
Title: Scalable Analysis of Differential Transcript Usage for Bulk and
        Single-Cell RNA-sequencing Applications
Date: 2022-08-05
Version: 1.10.0
Authors@R: c(person("Jeroen", "Gilis", role = c("aut","cre"),
                     email = "jeroen.gilis@ugent.be"),
             person("Kristoffer", "Vitting-Seerup", role = "ctb",
                     email = "kristoffer.vittingseerup@bio.ku.dk"),
	     person("Koen","Van den Berge", role = "ctb",
		     email = "koen.vandenberge@ugent.be"),
	     person("Lieven","Clement", role="ctb",
		     email = "Lieven.Clement@ugent.be"))
Description: satuRn provides a higly performant and scalable framework for performing
    differential transcript usage analyses. The package consists of three main functions.
    The first function, fitDTU, fits quasi-binomial generalized linear models that model
    transcript usage in different groups of interest. The second function, testDTU, tests    
    for differential usage of transcripts between groups of interest. Finally, plotDTU  
    visualizes the usage profiles of transcripts in groups of interest.
Depends: R (>= 4.1)
Imports: locfdr, SummarizedExperiment, BiocParallel, limma, pbapply,
        ggplot2, boot, Matrix, stats, methods, graphics
Suggests: knitr, rmarkdown, testthat, covr, BiocStyle, AnnotationHub,
        ensembldb, edgeR, DEXSeq, stageR, DelayedArray
VignetteBuilder: knitr
Collate: 'data.R' 'satuRn-framework.R' 'allGenerics.R' 'accessors.R'
        'fitDTU.R' 'testDTU.R' 'plotDTU.R'
License: Artistic-2.0
URL: https://github.com/statOmics/satuRn
BugReports: https://github.com/statOmics/satuRn/issues
Encoding: UTF-8
LazyData: false
RoxygenNote: 7.2.0
biocViews: Regression, ExperimentalDesign, DifferentialExpression,
        GeneExpression, RNASeq, Sequencing, Software, SingleCell,
        Transcriptomics, MultipleComparison, Visualization
git_url: https://git.bioconductor.org/packages/satuRn
git_branch: RELEASE_3_18
git_last_commit: 97878c3
git_last_commit_date: 2023-10-24
Date/Publication: 2023-10-24
NeedsCompilation: no
Packaged: 2023-10-24 22:52:40 UTC; biocbuild
Author: Jeroen Gilis [aut, cre],
  Kristoffer Vitting-Seerup [ctb],
  Koen Van den Berge [ctb],
  Lieven Clement [ctb]
Maintainer: Jeroen Gilis <jeroen.gilis@ugent.be>

Package: satuRn
Type: Package
Title: Scalable Analysis of Differential Transcript Usage for Bulk and
        Single-Cell RNA-sequencing Applications
Date: 2022-08-05
Version: 1.21.0
Authors@R: c(person("Jeroen", "Gilis", role = c("aut","cre"),
                     email = "jeroen.gilis@ugent.be"),
             person("Kristoffer", "Vitting-Seerup", role = "ctb",
                     email = "kristoffer.vittingseerup@bio.ku.dk"),
	     person("Koen","Van den Berge", role = "ctb",
		     email = "koen.vandenberge@ugent.be"),
	     person("Lieven","Clement", role="ctb",
		     email = "Lieven.Clement@ugent.be"))
Description: satuRn provides a higly performant and scalable framework for performing
    differential transcript usage analyses. The package consists of three main functions.
    The first function, fitDTU, fits quasi-binomial generalized linear models that model
    transcript usage in different groups of interest. The second function, testDTU, tests    
    for differential usage of transcripts between groups of interest. Finally, plotDTU  
    visualizes the usage profiles of transcripts in groups of interest.
Depends: R (>= 4.1)
Imports: locfdr, SummarizedExperiment, BiocParallel, limma, pbapply,
        ggplot2, boot, Matrix, stats, methods, graphics
Suggests: knitr, rmarkdown, testthat, covr, BiocStyle, AnnotationHub,
        ensembldb, edgeR, DEXSeq, stageR, DelayedArray
VignetteBuilder: knitr
Collate: 'data.R' 'satuRn-framework.R' 'allGenerics.R' 'accessors.R'
        'fitDTU.R' 'testDTU.R' 'plotDTU.R'
License: Artistic-2.0
URL: https://github.com/statOmics/satuRn
BugReports: https://github.com/statOmics/satuRn/issues
Encoding: UTF-8
LazyData: false
RoxygenNote: 7.2.0
biocViews: Regression, ExperimentalDesign, DifferentialExpression,
        GeneExpression, RNASeq, Sequencing, Software, SingleCell,
        Transcriptomics, MultipleComparison, Visualization
git_url: https://git.bioconductor.org/packages/satuRn
git_branch: devel
git_last_commit: 82b1889
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 00:51:03 UTC; biocbuild
Author: Jeroen Gilis [aut, cre],
  Kristoffer Vitting-Seerup [ctb],
  Koen Van den Berge [ctb],
  Lieven Clement [ctb]
Maintainer: Jeroen Gilis <jeroen.gilis@ugent.be>

<!-- README.md is generated from README.Rmd. Please edit that file -->

# satuRn

<!-- badges: start -->

[![Lifecycle:
stable](https://img.shields.io/badge/lifecycle-stable-blue.svg)](https://www.tidyverse.org/lifecycle/#stable)
[![R build
status](https://github.com/statOmics/satuRn/workflows/R-CMD-check-bioc/badge.svg)](https://github.com/statOmics/satuRn/actions)
<!-- badges: end -->

satuRn is a highly performant and scalable method for performing
differential transcript usage analyses.

## NEWS

We report a bug in satuRn 1.4.0. (Bioconductor release 3.15). The bug
was inadvertently introduced in satuRn 1.3.1 (from the former
Bioconductor devel). Note that the bug was not thus present in any of
the older Bioconductor releases 3.13 and 3.14 (satuRn 1.0.x, 1.1.x and
1.2.x).

The bug has been resolved in the newer versions of satuRn (1.4.1 and
up). Therefore, satuRn 1.4.0. should no longer be used and updated to
the newer version. For more details on the bug, we refer to the
[NEWS](https://github.com/statOmics/satuRn/blob/master/NEWS.md)

## Installation instructions

To install the current version of `satuRn` in Bioconductor, run;

``` r
if(!requireNamespace("BiocManager", quietly = TRUE)) {
 install.packages("BiocManager") 
}
BiocManager::install("satuRn")
```

To install the development version, run;

``` r
devtools::install_github("statOmics/satuRn")
```

The installation should only take a few seconds. The dependencies of the
package are listed in the DESCRIPTION file of the package.

## Issues and bug reports

Please use <https://github.com/statOmics/satuRn/issues> to submit
issues, bug reports, and comments.

## Usage

A minimal example of the different functions for `modelling`, `testing`
and `visualizing` differential transcript usage is provided.

! See the online
[vignette](https://github.com/statOmics/satuRn/blob/master/vignettes/Vignette.Rmd)
or the satuRn [website](https://statomics.github.io/satuRn/) for a more
elaborate and reproducible example.

``` r
library(satuRn)
library(SummarizedExperiment)
```

Provide a transcript expression matrix and corresponding `colData` and
`rowData`

``` r
sumExp <- SummarizedExperiment::SummarizedExperiment(
    assays = list(counts = Tasic_counts_vignette),
    colData = Tasic_metadata_vignette,
    rowData = txInfo
)

# Specify design formula from colData
metadata(sumExp)$formula <- ~ 0 + as.factor(colData(sumExp)$group)
```

Next, we test for differential transcript usage with the function
`testDTU`. This function takes as input the `SummarizedExperiment`
object generated by `fitDTU` and a contrast matrix or vector. The latter
is used to specify the comparison(s) of interest and can either be
generated manually or automatically with the `makeContrasts` function of
the `limma` R package.

``` r
group <- as.factor(Tasic_metadata_vignette$group)
design <- model.matrix(~ 0 + group) # constructs design matrix
colnames(design) <- levels(group)
L <- limma::makeContrasts(Contrast1 = VISp.L5_IT_VISp_Hsd11b1_Endou - ALM.L5_IT_ALM_Tnc,
                          Contrast2 = VISp.L5_IT_VISp_Hsd11b1_Endou - ALM.L5_IT_ALM_Tmem163_Dmrtb1, 
                          levels = design) # constructs contrast matrix

sumExp <- satuRn::testDTU(object = sumExp, 
                          contrasts = L, 
                          plot = FALSE, 
                          sort = FALSE)
```

The test results are now saved into the `rowData` of our
`SummarizedExperiment` object under the name `fitDTUResult_` followed by
the name of the contrast of interest (i.e. the column names of the
contrast matrix). The results can be accessed as follows:

``` r
head(rowData(sumExp)[["fitDTUResult_Contrast1"]]) # first contrast
```

Finally, we may visualize the usage of select transcripts in select
groups of interest with `plotDTU`:

``` r
sumExp <- satuRn::testDTU(
    object = sumExp,
    contrasts = L,
    plot = FALSE,
    sort = FALSE
)
```

Finally, we may visualize the usage of select transcripts in select
groups of interest with `plotDTU`:

``` r
group1 <- colnames(sumExp)[colData(sumExp)$group == "VISp.L5_IT_VISp_Hsd11b1_Endou"]
group2 <- colnames(sumExp)[colData(sumExp)$group == "ALM.L5_IT_ALM_Tnc"]

plots <- satuRn::plotDTU(
    object = sumExp,
    contrast = "Contrast1",
    groups = list(group1, group2),
    coefficients = list(c(0, 0, 1), c(0, 1, 0)),
    summaryStat = "model",
    transcripts = c(
        "ENSMUST00000081554",
        "ENSMUST00000195963",
        "ENSMUST00000132062"
    ),
    genes = NULL,
    top.n = 6
)
```

``` r
# Example plot from our publication:
knitr::include_graphics("https://raw.githubusercontent.com/statOmics/satuRn/master/inst/figures/README-DTU_plot.png")
```

<img src="https://raw.githubusercontent.com/statOmics/satuRn/master/inst/figures/README-DTU_plot.png" width="75%" />

## Citation

Below is the citation output from using `citation('satuRn')` in R.
Please run this yourself to check for any updates on how to cite
**satuRn**.

``` r
print(citation("satuRn"), bibtex = TRUE)
```

    ## 
    ## Gilis J (2022). _Scalable Analysis of differential Transcript Usage for
    ## bulk and single-Cell RNA-sequencing applications_. doi:
    ## 10.18129/B9.bioc.satuRn (URL: https://doi.org/10.18129/B9.bioc.satuRn),
    ## https://github.com/statOmics/satuRn - R package version 1.5.3, <URL:
    ## http://www.bioconductor.org/packages/satuRn>.
    ## 
    ## A BibTeX entry for LaTeX users is
    ## 
    ##   @Manual{,
    ##     title = {Scalable Analysis of differential Transcript Usage for bulk and single-Cell RNA-sequencing applications},
    ##     author = {Jeroen Gilis},
    ##     year = {2022},
    ##     url = {http://www.bioconductor.org/packages/satuRn},
    ##     note = {https://github.com/statOmics/satuRn - R package version 1.5.3},
    ##     doi = {10.18129/B9.bioc.satuRn},
    ##   }
    ## 
    ## Gilis J, Vitting-Seerup K, Van den Berge K, Clement L (2021). "Scalable
    ## Analysis of Differential Transcript Usage for Bulk and Single-Cell
    ## RNA-sequencing Applications." _F1000_. doi:
    ## (https://doi.org/10.12688/f1000research.51749.1 (URL:
    ## https://doi.org/%28https%3A//doi.org/10.12688/f1000research.51749.1),
    ## <URL: https://f1000research.com/articles/10-374/v1>.
    ## 
    ## A BibTeX entry for LaTeX users is
    ## 
    ##   @Article{,
    ##     title = {Scalable Analysis of Differential Transcript Usage for Bulk and Single-Cell RNA-sequencing Applications},
    ##     author = {Jeroen Gilis and Kristoffer Vitting-Seerup and Koen {Van den Berge} and Lieven Clement},
    ##     year = {2021},
    ##     journal = {F1000},
    ##     doi = {(https://doi.org/10.12688/f1000research.51749.1},
    ##     url = {https://f1000research.com/articles/10-374/v1},
    ##   }

Please note that the `satuRn` was only made possible thanks to many
other R and bioinformatics software authors, which are cited either in
the vignettes and/or the paper(s) describing this package.

## Code of Conduct

Please note that the `satuRn` project is released with a [Contributor
Code of
Conduct](https://contributor-covenant.org/version/2/0/CODE_OF_CONDUCT.html).
By contributing to this project, you agree to abide by its terms.

## Development tools

-   Continuous code testing is possible thanks to [GitHub
    actions](https://www.tidyverse.org/blog/2020/04/usethis-1-6-0/)
    through *[usethis](https://CRAN.R-project.org/package=usethis)*,
    *[remotes](https://CRAN.R-project.org/package=remotes)*, and
    *[rcmdcheck](https://CRAN.R-project.org/package=rcmdcheck)*
    customized to use [Bioconductor’s docker
    containers](https://www.bioconductor.org/help/docker/) and
    *[BiocCheck](https://bioconductor.org/packages/3.15/BiocCheck)*.
-   Code coverage assessment is possible thanks to
    [codecov](https://codecov.io/gh) and
    *[covr](https://CRAN.R-project.org/package=covr)*.
-   The [documentation website](http://statOmics.github.io/satuRn) is
    automatically updated thanks to
    *[pkgdown](https://CRAN.R-project.org/package=pkgdown)*.
-   The code is styled automatically thanks to
    *[styler](https://CRAN.R-project.org/package=styler)*.
-   The documentation is formatted thanks to
    *[devtools](https://CRAN.R-project.org/package=devtools)* and
    *[roxygen2](https://CRAN.R-project.org/package=roxygen2)*.

For more details, check the `dev` directory.

This package was developed using
*[biocthis](https://github.com/lcolladotor/biocthis)*.

---
output: github_document
---

<!-- README.md is generated from README.Rmd. Please edit that file -->

# satuRn

<!-- badges: start -->
[![Lifecycle: stable](https://img.shields.io/badge/lifecycle-stable-blue.svg)](https://www.tidyverse.org/lifecycle/#stable)
[![R build status](https://github.com/statOmics/satuRn/workflows/R-CMD-check-bioc/badge.svg)](https://github.com/statOmics/satuRn/actions)
<!-- badges: end -->

satuRn is a highly performant and scalable method for performing differential transcript usage analyses.

## NEWS

We report a bug in satuRn 1.4.0. (Bioconductor release 3.15). The bug was
inadvertently introduced in satuRn 1.3.1 (from the former Bioconductor devel).
Note that the bug was not thus present in any of the older Bioconductor releases 
3.13 and 3.14 (satuRn 1.0.x, 1.1.x and 1.2.x).

The bug has been resolved in the newer versions of satuRn (1.4.1 and up).
Therefore, satuRn 1.4.0. should no longer be
used and updated to the newer version. For more details on the bug, we refer
to the [NEWS](https://github.com/statOmics/satuRn/blob/master/NEWS.md)

## Installation instructions

To install the current version of `satuRn` in Bioconductor, run;

```{r 'install_bioc', eval = FALSE}
if(!requireNamespace("BiocManager", quietly = TRUE)) {
 install.packages("BiocManager") 
}
BiocManager::install("satuRn")
```

To install the development version, run;

```{r 'install_dev', eval = FALSE}
devtools::install_github("statOmics/satuRn")
```

The installation should only take a few seconds.
The dependencies of the package are listed in the DESCRIPTION file of the package.

## Issues and bug reports

Please use https://github.com/statOmics/satuRn/issues to submit issues, bug reports, and comments.

## Usage 

A minimal example of the different functions for `modelling`, `testing` and `visualizing` differential transcript usage is provided. 

! See the online [vignette](https://github.com/statOmics/satuRn/blob/master/vignettes/Vignette.Rmd) or the satuRn [website](https://statomics.github.io/satuRn/) for a more elaborate and reproducible example.

```{r, eval = FALSE}
library(satuRn)
library(SummarizedExperiment)
```

Provide a transcript expression matrix and corresponding `colData` and `rowData`

```{r, eval = FALSE}
sumExp <- SummarizedExperiment::SummarizedExperiment(
    assays = list(counts = Tasic_counts_vignette),
    colData = Tasic_metadata_vignette,
    rowData = txInfo
)

# Specify design formula from colData
metadata(sumExp)$formula <- ~ 0 + as.factor(colData(sumExp)$group)
```

Next, we test for differential transcript usage with the function
`testDTU`. This function takes as input the `SummarizedExperiment`
object generated by `fitDTU` and a contrast matrix or vector. The latter
is used to specify the comparison(s) of interest and can either be
generated manually or automatically with the `makeContrasts` function of
the `limma` R package.

```{r, eval = FALSE}
group <- as.factor(Tasic_metadata_vignette$group)
design <- model.matrix(~ 0 + group) # constructs design matrix
colnames(design) <- levels(group)
L <- limma::makeContrasts(Contrast1 = VISp.L5_IT_VISp_Hsd11b1_Endou - ALM.L5_IT_ALM_Tnc,
                          Contrast2 = VISp.L5_IT_VISp_Hsd11b1_Endou - ALM.L5_IT_ALM_Tmem163_Dmrtb1, 
                          levels = design) # constructs contrast matrix

sumExp <- satuRn::testDTU(object = sumExp, 
                          contrasts = L, 
                          plot = FALSE, 
                          sort = FALSE)
```

The test results are now saved into the `rowData` of our
`SummarizedExperiment` object under the name `fitDTUResult_` followed by
the name of the contrast of interest (i.e. the column names of the
contrast matrix). The results can be accessed as follows:

```{r, eval = FALSE}
head(rowData(sumExp)[["fitDTUResult_Contrast1"]]) # first contrast
```

Finally, we may visualize the usage of select transcripts in select
groups of interest with `plotDTU`:

```{r, eval = FALSE}
sumExp <- satuRn::testDTU(
    object = sumExp,
    contrasts = L,
    plot = FALSE,
    sort = FALSE
)
```

Finally, we may visualize the usage of select transcripts 
in select groups of interest with `plotDTU`:

```{r, eval = FALSE}
group1 <- colnames(sumExp)[colData(sumExp)$group == "VISp.L5_IT_VISp_Hsd11b1_Endou"]
group2 <- colnames(sumExp)[colData(sumExp)$group == "ALM.L5_IT_ALM_Tnc"]

plots <- satuRn::plotDTU(
    object = sumExp,
    contrast = "Contrast1",
    groups = list(group1, group2),
    coefficients = list(c(0, 0, 1), c(0, 1, 0)),
    summaryStat = "model",
    transcripts = c(
        "ENSMUST00000081554",
        "ENSMUST00000195963",
        "ENSMUST00000132062"
    ),
    genes = NULL,
    top.n = 6
)
```

```{r out.width = "75%"}
# Example plot from our publication:
knitr::include_graphics("https://raw.githubusercontent.com/statOmics/satuRn/master/inst/figures/README-DTU_plot.png")
```

## Citation

Below is the citation output from using `citation('satuRn')` in R. Please
run this yourself to check for any updates on how to cite __satuRn__.

```{r 'citation', eval = requireNamespace('satuRn')}
print(citation("satuRn"), bibtex = TRUE)
```

Please note that the `satuRn` was only made possible thanks to many other R and bioinformatics software authors, which are cited either in the vignettes and/or the paper(s) describing this package.

## Code of Conduct

Please note that the `satuRn` project is released with a [Contributor Code of Conduct](https://contributor-covenant.org/version/2/0/CODE_OF_CONDUCT.html). By contributing to this project, you agree to abide by its terms.

## Development tools

* Continuous code testing is possible thanks to [GitHub actions](https://www.tidyverse.org/blog/2020/04/usethis-1-6-0/)  through `r BiocStyle::CRANpkg('usethis')`, `r BiocStyle::CRANpkg('remotes')`, and `r BiocStyle::CRANpkg('rcmdcheck')` customized to use [Bioconductor's docker containers](https://www.bioconductor.org/help/docker/) and `r BiocStyle::Biocpkg('BiocCheck')`.
* Code coverage assessment is possible thanks to [codecov](https://codecov.io/gh) and `r BiocStyle::CRANpkg('covr')`.
* The [documentation website](http://statOmics.github.io/satuRn) is automatically updated thanks to `r BiocStyle::CRANpkg('pkgdown')`.
* The code is styled automatically thanks to `r BiocStyle::CRANpkg('styler')`.
* The documentation is formatted thanks to `r BiocStyle::CRANpkg('devtools')` and `r BiocStyle::CRANpkg('roxygen2')`.

For more details, check the `dev` directory.

This package was developed using `r BiocStyle::Githubpkg('lcolladotor/biocthis')`.

#' @title The StatModel class for satuRn
#'
#' @description
#'
#' The `StatModel` class contains a statistical model generated by 
#' the DTU analysis.
#'
#' Models are created by the dedicated user-level function `fitDTU()`
#' or manually, using the `StatModel()` constructor.
#' In the former case, each quantitative feature is assigned its s
#' tatistical model and the models are stored as a variable in 
#' a `DataFrame` object, that in turn will  be stored in the `RowData` slot of 
#' a `SummarizedExperiment object`.
#'
#' @slot type `character(1)` defining type of the used model. Default is
#' `"fitError"`, i.e. an error model. 
#' If not an error, class type will be `"glm"`.
#' @slot params A `list()` containing the parameters of the fitted model.
#' @slot varPosterior `numeric()` of posterior variance.
#' @slot dfPosterior `numeric()` of posterior degrees of freedom.
#'
#' @rdname satuRn-framework
#'
#' @author Jeroen Gilis
#'
#' @export
#'
#' @examples
#' ## A fully specified dummy model
#' myModel <- StatModel(
#'     type = "glm",
#'     params = list(x = 3, y = 7, b = 4),
#'     varPosterior = c(0.1, 0.2, 0.3),
#'     dfPosterior = c(6, 7, 8)
#' )
#' myModel
.StatModel <- setClass("StatModel",
    slots = c(
        type = "character",
        params = "list",
        varPosterior = "numeric",
        dfPosterior = "numeric"
    )
)

#' @name StatModel
#' @title StatModel
#'
#' @description Function for contstructing a new `StatModel` object.
#'
#' @param type default set to fiterror, can be a glm
#'
#' @param params A list containing the parameters of the fitted glm
#'
#' @param varPosterior Numeric, posterior variance of the glm, default is NA
#'
#' @param dfPosterior Numeric, posterior degrees of freedom of the glm, 
#'     default is NA
#'
#' @examples
#' ## A fully specified dummy model
#' myModel <- StatModel(
#'     type = "glm",
#'     params = list(x = 3, y = 7, b = 4),
#'     varPosterior = c(0.1, 0.2, 0.3),
#'     dfPosterior = c(6, 7, 8)
#' )
#' myModel
#' @return A StatModel object
#'
#' @importFrom methods new
#'
#' @export

StatModel <- function(type = "fitError",
    params = list(),
    varPosterior = NA_real_,
    dfPosterior = NA_real_) {
    out <- new("StatModel")
    out@type <- type
    out@params <- params
    out@varPosterior <- varPosterior
    out@dfPosterior <- dfPosterior
    return(out)
}

context("StatModel construction")

test_that("StatModel construction", {
    ## Empty model
    expect_true(validObject(StatModel()))
    ## Default model type
    expect_identical(StatModel()@type, "fitError")
    ## Fully defined model
    mod <- StatModel(
        type = "glm",
        params = list(x = 3, y = 7, b = 4),
        varPosterior = c(0.1, 0.2, 0.3),
        dfPosterior = c(6, 7, 8)
    )
    expect_true(validObject(mod))
})

##############################################################

context("Statmodel accession") # 2/5 accessors tested

data("sumExp_example", package = "satuRn")

sumExp_example <- fitDTU(
    object = sumExp_example,
    formula = ~ 0 + group,
    parallel = FALSE,
    BPPARAM = BiocParallel::bpparam(),
    verbose = TRUE
)

mod1 <- rowData(sumExp_example)[["fitDTUModels"]]$"ENSMUST00000165123"
mod_empty <- StatModel()

test_that("model parameters can be accessed", {

    # test getModel
    expect_identical(class(getModel(mod1)), "list")
    expect_equal(length(getModel(mod1)), 4)
    expect_identical(class(getModel(mod_empty)), "list")
    expect_equal(length(getModel(mod_empty)), 0)

    # test getCoef
    expect_identical(class(getCoef(mod1)), "numeric")
    expect_identical(length(getCoef(mod1)), length(levels(as.factor(colData(sumExp_example)$group))))
})

##############################################################

context("fitDTU for different input types")

# load data
data("sumExp_example", package = "satuRn")

test_that("different fitDTU assay types give same results", {

    # matrix input type
    sumExp_mat <- sumExp_example
    sumExp_mat <- fitDTU(
        object = sumExp_mat,
        formula = ~ 0 + group,
        parallel = FALSE,
        BPPARAM = BiocParallel::bpparam(),
        verbose = TRUE
    )

    # DataFrame input type
    mat <- sumExp_example@assays@data$counts
    sumExp_df <- sumExp_example
    sumExp_df@assays@data$counts <- mat
    sumExp_df <- satuRn::fitDTU(
        object = sumExp_df,
        formula = ~ 0 + group,
        parallel = FALSE,
        BPPARAM = BiocParallel::bpparam(),
        verbose = TRUE
    )

    # sparseMatrix input type
    sumExp_sparse <- sumExp_example
    sumExp_sparse@assays@data$counts <- Matrix(mat, sparse = TRUE)
    sumExp_sparse <- satuRn::fitDTU(
        object = sumExp_sparse,
        formula = ~ 0 + group,
        parallel = FALSE,
        BPPARAM = BiocParallel::bpparam(),
        verbose = TRUE
    )

    # DelayedMatrix input type
    sumExp_delayed <- sumExp_example
    sumExp_delayed@assays@data$counts <- DelayedArray(mat)
    sumExp_delayed <- satuRn::fitDTU(
        object = sumExp_delayed,
        formula = ~ 0 + group,
        parallel = FALSE,
        BPPARAM = BiocParallel::bpparam(),
        verbose = TRUE
    )

    expect_equal(rowData(sumExp_mat)[["fitDTUModels"]], rowData(sumExp_df)[["fitDTUModels"]])
    expect_equal(rowData(sumExp_mat)[["fitDTUModels"]], rowData(sumExp_sparse)[["fitDTUModels"]])
    expect_equal(rowData(sumExp_mat)[["fitDTUModels"]], rowData(sumExp_delayed)[["fitDTUModels"]])
})

#' Accessor functions for StatModel class
#'
#' @description Accessor functions for StatModel class
#'     \describe{
#'         \item{getModel(object)}{to get model}
#'         \item{getDF(object)}{to get the residual degrees of freedom 
#'                 of the model}
#'         \item{getDfPosterior(object)}{to get the degrees of freedom of
#'                 the empirical Bayes variance estimator}
#'         \item{getDispersion(object)}{to get the dispersion estimate of 
#'                 the model}
#'         \item{getCoef(object)}{to get the parameter estimates of the mean 
#'                 model}
#'              }
#' @aliases statModelAccessors getModel getDF getDfPosterior getDispersion 
#' getCoef
#' @rdname statModelAccessors
#'
#' @param object StatModel object
#'
#' @examples
#' ## A fully specified dummy model
#' myModel <- StatModel(
#'     type = "glm",
#'     params = list(x = 3, y = 7, b = 4),
#'     varPosterior = c(0.1, 0.2, 0.3),
#'     dfPosterior = c(6, 7, 8)
#' )
#' getModel(myModel)
#' @return The requested parameter of the StatModel object

setMethod("getModel",
    signature = "StatModel",
    definition = function(object) object@params
)

#' @rdname statModelAccessors
#' @param object StatModel object
setMethod("getDF",
    signature = "StatModel",
    definition = function(object) object@params$df.residual
)

#' @rdname statModelAccessors
#' @param object StatModel object
setMethod("getDfPosterior",
    signature = "StatModel",
    definition = function(object) object@dfPosterior
)

#' @rdname statModelAccessors
#' @param object StatModel object
setMethod("getDispersion",
    signature = "StatModel",
    definition = function(object) object@params$dispersion
)

#' @rdname statModelAccessors
#' @param object StatModel object
setMethod("getCoef",
    signature = "StatModel",
    definition = function(object) object@params$coefficients
)

# Compute usage estimates (log-odds) in a contrast of interest
getEstimates <- function(object, contrast) {
    coef <- getCoef(object)
    
    if (is.null(coef) | any(is.na(coef[contrast!=0]))) { # NULL or NAs in current contrast
      return(NA)
    } else {
      coef[is.na(coef)] <- 0 # in case NAs would be presented in the not-relevant contrasts
      return(contrast %*% coef)
    }
}

# Compute the variance on the usage estimates in a contrast of interest
varContrast <- function(object, contrast) {
  if (object@type %in% c("fitError", "lonelyTranscript") |
      nrow(object@params$vcovUnsc) != length(contrast)){
    return(NA)
  } else{
    vcovTmp <- object@params$vcovUnsc * object@varPosterior
    if(!any(is.na(vcovTmp))){ # if no NAs, compute as normal
      return(diag(t(contrast) %*% vcovTmp %*% contrast))
    } else { # if NAs, see if they are problematic for the contrast
      vcovHlp <- vcovTmp
      vcovHlp[upper.tri(vcovHlp)] <- 0
      if(any(is.na(vcovTmp[contrast != 0, contrast != 0]))){ # problematic
        return(NA)
      } else{ # not problematic
        vcovTmp[is.na(vcovTmp)] <- 0
        return(diag(t(contrast) %*% vcovTmp %*% contrast))
      }
    }
  }
}

# The code is based on the source code of the unexported loccov function
# the locFDR package from CRAN https://CRAN.R-project.org/package=locfdr.
# The code is identical to locfdr:::loccov.
locfdr_loccov <- function (N, N0, p0, d, s, x, X, f, JV, Y, i0, H, h, sw) {
    
    M = rbind(1, x - Y[1], x^2 - Y[2])
    if (sw == 2) {
        K = length(x)
        K0 = length(i0)
        toprow = c(1 - N0/N, -t(h) %*% JV/s)
        botrow = cbind(0, JV/p0)
        mat = rbind(toprow, botrow)
        M0 = M[, i0]
        dpds.dy0 = mat %*% M0/N/H[1]
        dy0.dy = matrix(0, K0, K)
        dy0.dy[, i0] = diag(1, K0)
        dpds.dy = dpds.dy0 %*% dy0.dy
        rownames(dpds.dy) = c("p", "d", "s")
        return(dpds.dy)
    }
    else {
        xstd = (x - d)/s
        U = cbind(xstd - H[2]/H[1], xstd^2 - H[3]/H[1])
        M[, -i0] = 0
        dl0plus.dy = cbind(1 - N0/N, U %*% JV/s) %*% M/N/H[1]/p0
        G <- t(X) %*% (f * X)
        dl.dy = X %*% solve(G) %*% t(X)
        dlfdr.dy = dl0plus.dy - dl.dy
        if (sw == 3) 
            return(dlfdr.dy)
        else {
            Cov.lfdr = dlfdr.dy %*% (f * t(dlfdr.dy))
            return(Cov.lfdr)
        }
    }
}

# The code is based on the source code of the unexported locmle function
# the locFDR package from CRAN https://CRAN.R-project.org/package=locfdr.
# The code is almost identical to locfdr:::locmle, with exception of some minor
# adaptations to the coding style which were required to abide by 
# the current Bioconductor coding style guides (2021-02-25)
locfdr_locmle <- function(z, xlim, Jmle = 35, d = 0, s = 1, 
                            ep = 1/1e+05, sw = 0, Cov.in) {
    
    N = length(z)
    if (missing(xlim)) {
        if (N > 5e+05) 
            b = 1
        else b = 4.3 * exp(-0.26 * log(N, 10))
        xlim = c(median(z), b * diff(quantile(z)[c(2, 4)])/(2 * qnorm(0.75)))
    }
    aorig = xlim[1] - xlim[2]
    borig = xlim[1] + xlim[2]
    z0 = z[which(z >= aorig & z <= borig)]
    N0 = length(z0)
    Y = c(mean(z0), mean(z0^2))
    that = N0/N
    for (j in seq_len(Jmle)) {
        bet = c(d/s^2, -1/(2 * s^2))
        aa = (aorig - d)/s
        bb = (borig - d)/s
        H0 = pnorm(bb) - pnorm(aa)
        fa = dnorm(aa)
        fb = dnorm(bb)
        H1 = fa - fb
        H2 = H0 + aa * fa - bb * fb
        H3 = (2 + aa^2) * fa - (2 + bb^2) * fb
        H4 = 3 * H0 + (3 * aa + aa^3) * fa - (3 * bb + bb^3) * 
            fb
        H = c(H0, H1, H2, H3, H4)
        r = d/s
        I = matrix(rep(0, 25), 5)
        for (i in seq(from=0,to=4)) I[i + 1, 0:(i + 1)] = choose(i, 0:i)
        u1 = s^(0:4)
        II = pmax(row(I) - col(I), 0)
        II = r^II
        I = u1 * (I * II)
        E = as.vector(I %*% H)/H0
        E1 = E[2]
        E2 = E[3]
        E3 = E[4]
        E4 = E[5]
        mu = c(E1, E2)
        V = matrix(c(E2 - E1^2, E3 - E1 * E2, E3 - E1 * E2, E4 - 
                         E2^2), 2)
        bett = bet + solve(V, Y - mu)/(1 + 1/j^2)
        if (bett[2] > 0) 
            bett = bet + 0.1 * solve(V, Y - mu)/(1 + 1/j^2)
        if (is.na(bett[2])) 
            break
        else if (bett[2] >= 0) 
            break
        d = -bett[1]/(2 * bett[2])
        s = 1/sqrt(-2 * bett[2])
        if (sum((bett - bet)^2)^0.5 < ep) 
            break
    }
    if (is.na(bett[2])) {
        mle = rep(NA, 6)
        Cov.lfdr = NA
        Cor = matrix(NA, 3, 3)
    }
    else if (bett[2] >= 0) {
        mle = rep(NA, 6)
        Cov.lfdr = Cov.out = NA
        Cor = matrix(NA, 3, 3)
    }
    else {
        aa = (aorig - d)/s
        bb = (borig - d)/s
        H0 = pnorm(bb) - pnorm(aa)
        p0 = that/H0
        J = s^2 * matrix(c(1, 0, 2 * d, s), 2)
        JV = J %*% solve(V)
        JVJ = JV %*% t(J)
        mat2 = cbind(0, JVJ/N0)
        mat1 = c((p0 * H0 * (1 - p0 * H0))/N, 0, 0)
        mat = rbind(mat1, mat2)
        h = c(H1/H0, (H2 - H0)/H0)
        matt = c(1/H0, -(p0/s) * t(h))
        matt = rbind(matt, cbind(0, diag(2)))
        C = matt %*% (mat %*% t(matt))
        mle = c(p0, d, s, diag(C)^0.5)
        if (sw == 1) {
            sd = mle[4:6]
            Co = C/outer(sd, sd)
            dimnames(Co) = list(c("p0", "d", "s"), c("p0", "d", "s"))
            Cor = Co[c(2, 3, 1), c(2, 3, 1)]
        }
        if (!missing(Cov.in)) {
            i0 = which(Cov.in$x > aa & Cov.in$x < bb)
            Cov.out = locfdr_loccov(N, N0, p0, d, s, Cov.in$x, Cov.in$X, 
                                    Cov.in$f, JV, Y, i0, H, h, Cov.in$sw)
        }
    }
    names(mle) = c("p0", "del0", "sig0", "sd.p0", "sd.del0", "sd.sig0")
    mle = mle[c(2, 3, 1, 5, 6, 4)]
    out = list(mle = mle)
    if (sw == 1) {
        Cor = list(Cor = Cor)
        out = c(out, Cor)
    }
    if (!missing(Cov.in)) {
        if (Cov.in$sw == 2) {
            pds. = list(pds. = Cov.out)
            out = c(out, pds.)
        }
        else if (Cov.in$sw == 3) {
            Ilfdr = list(Ilfdr = Cov.out)
            out = c(out, Ilfdr)
        }
        else {
            Cov.lfdr = list(Cov.lfdr = Cov.out)
            out = c(out, Cov.lfdr)
        }
    }
    if ((sw == 1) | !missing(Cov.in)) 
        return(out)
    else return(mle)
}

# Compute p-values under an empirical null distribution
# The code is based on the source code of 
# the locFDR package https://CRAN.R-project.org/package=locfdr
p.adjust_empirical <- function(pvalues, 
                               tvalues,
                               main,
                               diagplot1,
                               diagplot2) {
    zvalues <- qnorm(pvalues / 2) * sign(tvalues)
    
    # to avoid locFDR (numerical) fit errors if abs(z) is extremely large
    zvalues_mid <- zvalues[abs(zvalues) < 10]
    zvalues_mid <- zvalues_mid[!is.na(zvalues_mid)]
    
    if(diagplot1){
        plot <- locfdr(zz = zvalues_mid,
                       main = paste0("diagplot 1: ", main))
    }

    #### start code from locFDR package
    N <- length(zvalues_mid)
    b <- 4.3 * exp(-0.26 * log(N, 10))
    med <- median(zvalues_mid)
    sc <- diff(quantile(zvalues_mid)[c(2, 4)]) / (2 * qnorm(.75))
    # initial MLEs of empirical null parameters
    mlests <- locfdr_locmle(zvalues_mid, xlim = c(med, b * sc))

    lo <- min(zvalues_mid)
    up <- max(zvalues_mid)
    bre <- 120
    breaks <- seq(lo, up, length = bre)
    zzz <- pmax(pmin(zvalues_mid, up), lo)
    zh <- hist(zzz, breaks = breaks, plot = FALSE)
    x <- (breaks[-1] + breaks[-length(breaks)]) / 2
    sw <- 0
    X <- cbind(1, poly(x, df = 7))
    zh <- hist(zzz, breaks = breaks, plot = FALSE)
    y <- zh$counts
    f <- glm(y ~ poly(x, df = 7), poisson)$fit

    Cov.in <- list(x = x, X = X, f = f, sw = sw)
    ml.out <- locfdr_locmle(zvalues_mid,
        xlim = c(mlests[1], b * mlests[2]),
        d = mlests[1], s = mlests[2], Cov.in = Cov.in
    ) # updated MLEs of empirical null parameters
    mlests <- ml.out$mle
    #### end code from locFDR package

    zval_empirical <- (zvalues - mlests[1]) / mlests[2]
    # p-values under empirical null
    pval_empirical <- 2 * pnorm(-abs(zval_empirical), mean = 0, sd = 1) 

    if (diagplot2) {
        zval_empirical_mid <- zval_empirical[abs(zval_empirical) < 10]
        zval_empirical_mid <- zval_empirical_mid[!is.na(zval_empirical_mid)]
        lo <- min(zval_empirical_mid)
        up <- max(zval_empirical_mid)

        lo <- min(lo, -1 * up) # to center the figure
        up <- max(up, -1 * lo)

        bre <- 120
        breaks <- seq(lo, up, length = bre)
        zzz <- pmax(pmin(zval_empirical_mid, up), lo)
        zh <- hist(zzz, breaks = breaks, plot = FALSE)
        yall <- zh$counts
        K <- length(yall)

        hist(zzz, breaks = breaks, xlab = "z-scores", 
            main = paste0("diagplot 2: ", main), freq = FALSE)
        xfit <- seq(min(zzz), max(zzz), length = 4000)
        yfit <- dnorm(xfit / mlests[3], mean = 0, sd = 1)
        lines(xfit, yfit, col = "darkgreen", lwd = 2)
    }

    FDR <- p.adjust(pval_empirical, method = "BH")
    newList <- list("pval" = pval_empirical, "FDR" = FDR)
    return(newList)
}

#' Test function to obtain a top list of transcripts that are
#' differentially used in the contrast of interest
#'
#' @description Function to test for differential transcript usage (DTU)
#'
#' @param object A `SummarizedExperiment` instance containing a list of objects 
#'     of the `StatModel` class as obtained by the `fitDTU` function of the 
#'     `satuRn` package.
#'
#' @param contrasts `numeric` matrix specifying one or more contrasts of 
#'     the linear model coefficients to be tested. The rownames of the matrix 
#'     should be equal to the names of parameters of the model that are 
#'     involved in the contrast. The column names of the matrix will be used 
#'     to construct names to store the results in the rowData of 
#'     the SummarizedExperiment.
#'     
#' @param diagplot1 `boolean(1)` Logical, defaults to TRUE. If set to TRUE,
#'     a plot of the histogram of the z-scores (computed from p-values) is 
#'     displayed using the locfdr function of the `locfdr` package. The blue 
#'     dashed curve is fitted to the mid 50% of the z-scores, which are assumed 
#'     to originate from null transcripts, thus representing the estimated 
#'     empirical null component densities. The maximum likelihood estimates 
#'     (MLE) and central matching estimates  (CME) of this estimated empirical 
#'     null distribution are given below the plot. If the values for delta and
#'     sigma deviate from 0 and 1 respectively, the downstream inference will 
#'     be influenced by the empirical adjustment implemented in satuRn.
#'
#' @param diagplot2 `boolean(1)` Logical, defaults to TRUE. If set to TRUE,
#'     a plot of the histogram of the "empirically adjusted" test statistics and 
#'     the standard normal distribution will be displayed. Ideally, the majority
#'     (mid portion) of the adjusted test statistics should follow the standard 
#'     normal.
#'
#' @param sort `boolean(1)` Logical, defaults to FALSE. If set to TRUE, 
#'     the output of the topTable test function is sorted according to 
#'     the empirical p-values.
#'
#' @examples
#' data(sumExp_example, package = "satuRn")
#' library(SummarizedExperiment)
#' sumExp <- fitDTU(
#'     object = sumExp_example,
#'     formula = ~ 0 + group,
#'     parallel = FALSE,
#'     BPPARAM = BiocParallel::bpparam(),
#'     verbose = TRUE
#' )
#' group <- as.factor(colData(sumExp)$group)
#' design <- model.matrix(~ 0 + group)
#' colnames(design) <- levels(group)
#' L <- matrix(0, ncol = 2, nrow = ncol(design))
#' rownames(L) <- colnames(design)
#' colnames(L) <- c("Contrast1", "Contrast2")
#' L[c("VISp.L5_IT_VISp_Hsd11b1_Endou", 
#'     "ALM.L5_IT_ALM_Tnc"), 1] <- c(1, -1)
#' L[c("VISp.L5_IT_VISp_Hsd11b1_Endou", 
#'     "ALM.L5_IT_ALM_Tmem163_Dmrtb1"), 2] <- c(1, -1)
#'
#' sumExp <- testDTU(object = sumExp, 
#'     contrasts = L, 
#'     diagplot1 = FALSE,
#'     diagplot2 = FALSE,
#'     sort = FALSE)
#' @return An updated `SummarizedExperiment` that contains the `Dataframes` 
#'     that display the significance of DTU for each transcript 
#'     in each contrast of interest.
#'
#' @rdname testDTU
#'
#' @author Jeroen Gilis
#'
#' @importFrom locfdr locfdr
#' @importFrom stats qnorm median quantile poly glm poisson pnorm dnorm 
#' p.adjust pt
#' @importFrom graphics hist lines
#' @importFrom SummarizedExperiment colData
#'
#' @export

testDTU <- function(object, 
                    contrasts,
                    diagplot1 = TRUE,
                    diagplot2 = TRUE, 
                    sort = FALSE) {
    if (is.null(rowData(object)[["fitDTUModels"]])) {
        stop("fitDTUModels is empty. Did you run fitDTU first?")    
    }
    models <- rowData(object)[["fitDTUModels"]] # call rowData only once

    for (i in seq_len(ncol(contrasts))) {
        estimates <- vapply(
            X = models,
            FUN =  function(x) tryCatch(getEstimates(x,contrasts[,i]), 
                                        error = function(err) NA),
            FUN.VALUE = numeric(1)
        )
        se <- sqrt(vapply(
            X = models,
            FUN = varContrast,
            contrast = contrasts[, i],
            FUN.VALUE = numeric(1)
        ))
        df <- vapply(
            X = models,
            FUN = getDfPosterior,
            FUN.VALUE = numeric(1)
        )

        df[!(vapply(df, length, numeric(1)))] <- NA # replace numeric(0) with NA
        df <- unlist(df)

        t <- estimates / se
        pval <- pt(-abs(t), df) * 2
        regular_FDR <- p.adjust(pval, method = "BH") # regular FDR correction
        
        if(sum(!is.na(pval)) < 500){
          warning(paste0("Less than 500 features with non-NA results for contrast ",
                         i, ": not running empirical correction"))
          
          result_contrast <- data.frame(
            estimates, se, df, t, pval, regular_FDR
          )
          
          if (sort == TRUE) {
            result_contrast <- result_contrast[order(result_contrast$pval), ]
          }
          result_contrast$empirical_pval <- NA
          result_contrast$empirical_FDR <- NA
          rowData(object)[[paste0("fitDTUResult_", 
                                  colnames(contrasts)[i])]] <- result_contrast
        } else{
          # empirical FDR correction    
          empirical <- satuRn:::p.adjust_empirical(pval, 
                                                   t, 
                                                   main = colnames(contrasts)[i], 
                                                   diagplot1 = TRUE, 
                                                   diagplot2 = TRUE) 
          empirical_pval <- empirical$pval
          empirical_FDR <- empirical$FDR
          
          result_contrast <- data.frame(
            estimates, se, df, t, pval, regular_FDR, empirical_pval,
            empirical_FDR
          )
          
          if (sort == TRUE) {
            result_contrast <- result_contrast[order(
              result_contrast$empirical_pval), ]
          }
          rowData(object)[[paste0("fitDTUResult_", 
                                  colnames(contrasts)[i])]] <- result_contrast
        }
    }
    return(object)
}

#' A `Matrix` with transcript-level counts 
#' derived from our case study which  builds on the dataset of Tasic et al. 
#' We used Salmon (V1.1.0) to quantify all L5IT cells 
#' (both for ALM and VISp tissue) from mice with a normal eye condition. 
#' From these cells, we randomly sampled 20 cells of each of the following 
#' cell types to use for this vignette;
#' L5_IT_VISp_Hsd11b1_Endou, L5_IT_ALM_Tmem163_Dmrtb1 and L5_IT_ALM_Tnc. 
#' The data has already been leniently filtered with 
#' the `filterByExpr` function of edgeR.
#' @usage data(Tasic_counts_vignette)
"Tasic_counts_vignette"

#' Metadata associated with the expression matrix `Tasic_counts_vignette`. 
#' See `?Tasic_counts_vignette` for more information on the dataset.
#'
#' @usage data(Tasic_metadata_vignette)
"Tasic_metadata_vignette"

#' A `SummarizedExperiment` derived from our case study which builds on 
#' the dataset of Tasic et al. It contains the same cells as the data object 
#' used in the vignette (see `?Tasic_counts_vignette` for more information). 
#' In this SummarizedExperiment, we performed a filtering with `filterByExpr` 
#' of edgeR with more stringent than default parameter settings 
#' (min.count = 100,min.total.count = 200, large.n = 50, min.prop = 0.9) to 
#' reduced the number of retained transcripts. We used this object to create 
#' an executable example in the help files of satuRn.
#'
#' @usage data(sumExp_example)
"sumExp_example"

#' @export
setGeneric("getModel", function(object) standardGeneric("getModel"))

#' @export
setGeneric("getDF", function(object) standardGeneric("getDF"))

#' @export
setGeneric("getDfPosterior", function(object) standardGeneric("getDfPosterior"))

#' @export
setGeneric("getDispersion", function(object) standardGeneric("getDispersion"))

#' @export
setGeneric("getCoef", function(object) standardGeneric("getCoef"))

#' @export
#' @name fitDTU
#' @title fitDTU
#' @param ... parameters including:
setGeneric("fitDTU", function(object, ...) standardGeneric("fitDTU"))

# Computes the gene-level count in each sample or cell in the data.
# Essentially taking the sum of the counts for each transcript within a gene.
getTotalCount <- function(countData, tx2gene) {
    # get tx2gene in better format
    geneForEachTx <- tx2gene$gene_id[match(rownames(countData), 
                                            tx2gene$isoform_id)]
    geneForEachTx <- as.character(geneForEachTx)
    stopifnot(class(geneForEachTx) %in% c("character", "factor"))
    stopifnot(length(geneForEachTx) == nrow(countData))

    # adapted from DEXSeq source code
    forCycle <- split(seq_len(nrow(countData)), as.character(geneForEachTx))
    all <- lapply(forCycle, function(i) {
        sct <- countData[i, , drop = FALSE]
        rs <- t(vapply(seq_len(nrow(sct)), function(r) 
            colSums(sct[, , drop = FALSE]), numeric(ncol(countData))))
        rownames(rs) <- rownames(sct)
        rs
    })

    totalCount <- do.call(rbind, all)
    totalCount <- totalCount[rownames(countData), ]
    return(totalCount)
}

# Helper function for creating the facet header in the figure
label_facet <- function(txID, padj) {
    lev <- levels(as.factor(txID))
    lab <- paste0("satuRn empFDR = ", padj)
    names(lab) <- lev
    return(lab)
}

# Worker function of the plotDTU wrapper function
plotDTU_internal <- function(object, topTable, contrast, coefficients, groups, 
                            summaryStat, tx2gene, transcripts) {
    group <- modelled_value <- NULL
    plotList <- list()
    countData <- assay(object)

    # To calculate usages, we also need the info of transcripts that we do not 
    # want to visualize, i.e. all transcripts of all corresponding genes
    genes <- unique(tx2gene[match(transcripts, tx2gene$isoform_id), "gene_id"])
    transcripts_all <- tx2gene[tx2gene$gene_id %in% genes, "isoform_id"]

    # assign cells to a certain group (violin)
    names(groups) <- seq_along(groups)
    cell_to_group <- unlist(groups)
    names(cell_to_group) <- rep(paste0("violin", names(groups)), 
                                times = lengths(groups))

    countData <- countData[transcripts_all, unlist(groups)]
    countData <- as.matrix(countData) # make matrix from possible sparseMatrix
    tx2gene <- tx2gene[tx2gene$isoform_id %in% transcripts_all, ]

    # get total counts (gene-level count) and 
    # usages (relative proportion of expression)
    totalCount <- getTotalCount(countData, tx2gene)
    usage <- countData / totalCount

    # subset to only the transcripts we want to plot
    usage <- usage[transcripts, , drop = FALSE]
    totalCount <- totalCount[transcripts, , drop = FALSE]

    # plot each of the requested transcripts
    for (i in seq_along(transcripts)) {
        transcript <- transcripts[i]

        # get all data and lay-out features to plot current transcript
        data <- as.data.frame(cbind(t(usage[transcript, , drop = FALSE]), 
                                    t(totalCount[transcript, , drop = FALSE])))
        data$group <- names(cell_to_group)[match(rownames(data), cell_to_group)]
        colnames(data) <- c("usage", "totalCount", "group")
        data$group <- as.factor(data$group)
        data$usage <- as.numeric(data$usage)
        data$totalCount <- as.numeric(data$totalCount)
        data$variable <- transcript # for adding Tx as a label to the facet
        padj <- format(topTable[transcript, "empirical_FDR"], digits = 4)
        gene <- tx2gene[tx2gene$isoform_id == transcript, "gene_id"]

        # violin plot
        gg <- ggplot(data = data, 
                    aes(x = group, y = usage, fill = group, 
                        width = totalCount)) +
            geom_violin() +
            geom_point(data = data, 
                    aes(x = group, y = usage, size = totalCount), 
                    position = position_jitterdodge(jitter.width = 0.7, 
                                                    jitter.height = 0, 
                                                    dodge.width = 0.9)) +
            scale_radius(name = "expression", range = c(0, 5)) +
            ylim(c(-0.05, 1.05)) +
            ylab("Fraction of usage") +
            theme_bw() +
            ggtitle(paste0(transcript, "  -  ", gene)) +
            theme(plot.title = element_text(size = 9.5, face = "bold")) +
            facet_wrap(~variable, 
                        ncol = 1, 
                        labeller = labeller(variable = label_facet(
                            data$variable, padj))) +
            theme(axis.text.x = element_text(angle = 45, vjust = 1, 
                                                hjust = 1, size = 8)) +
            theme(strip.text = element_text(size = 7, face = "bold"))

        # add summarystats
        if ("model" %in% summaryStat) {
            model_estimates <- rowData(
                object)[["fitDTUModels"]][transcript][[1]]@params$coefficients

            coefs <- do.call(rbind, coefficients)
            if(!any(is.na(model_estimates))){
              requested_estimates <- boot::inv.logit(coefs %*% model_estimates)
            } else if(any(!is.na(model_estimates[colSums(coefs != 0) > 0]))) {
              model_estimates[is.na(model_estimates)] <- 0
              requested_estimates <- boot::inv.logit(coefs %*% model_estimates)
            } else{
              stop(paste0("The modeled average usage of transcript ",
                          transcript, " could not be computed"))
            }
            data$modelled_value <- data$group
            levels(data$modelled_value) <- requested_estimates
            data$modelled_value <- as.numeric(as.character(data$modelled_value))

            gg <- gg +
                geom_point(data = data, 
                        aes(x = group, y = modelled_value), 
                            position = position_jitterdodge(jitter.width = 0, 
                                                            jitter.height = 0, 
                                                            dodge.width = 0.9), 
                            shape = 18, size = 5, colour = "gold2")
        }

        if ("mean" %in% summaryStat) {
            gg <- gg + stat_summary(fun = mean, geom = "point", 
                                    position = position_dodge(width = 0.9), 
                                    shape = 18, size = 4, colour = "cyan")
        }

        if ("median" %in% summaryStat) {
            gg <- gg + stat_summary(fun = median, geom = "point", 
                                    position = position_dodge(width = 0.9), 
                                    shape = 18, size = 3, colour = "darkgreen")
        }

        # save current ggplot in list
        plotList[[i]] <- gg
    }
    return(plotList)
}

#' Plot function to visualize differential transcript usage (DTU)
#'
#' @description Plot function to visualize differential transcript usage (DTU)
#'
#' @param object A `SummarizedExperiment` containing the models and results
#'     of the DTU analysis as obtained by the `fitDTU` and `testDTU` function 
#'     from this `satuRn` package, respectively.
#'
#' @param contrast Specifies the specific contrast for which the visualization 
#'     should be returned. This should be one of the column names of 
#'     the contrast matrix that was provided to the `testDTU` function.
#'
#' @param groups A `list` containing two character vectors.
#'     Each character vector contains the names (sample names or cell names) 
#'     of the respective groups in the target contrast.
#'
#' @param coefficients A `list` containing two numeric vectors. 
#'     Each numeric vector specifies the model coefficient of the corresponding 
#'     groups in the selected contrast.
#'
#' @param summaryStat Which summary statistic for the relative usage of 
#'     the transcript should be displayed. `Character` or `character vector`, 
#'     must be any of following summary statistics; model (default), 
#'     mean or median.
#'
#' @param transcripts A `character` or `character vector` of transcript IDs,
#'     to specify which transcripts should be visualized. Can be used together 
#'     with `genes`. If not specified, `plotDTU` will check if the `genes` slot 
#'     is specified.
#'
#' @param genes A single `character` or `character vector` of gene IDs,
#'     to specify the genes for which the individual transcripts should be 
#'     visualized. Can be used together with `transcripts`. If not specified, 
#'     `plotDTU` will check if the `transcripts` slot is specified.
#'
#' @param top.n A `numeric` value. If neither `transcripts` nor `genes` was
#'     was specified, this argument leads to the visualization of the `n` most
#'     significant DTU transcripts in the contrast. Defaults to 6 transcripts.
#'
#' @examples
#' data(sumExp_example, package = "satuRn")
#' library(SummarizedExperiment)
#' sumExp <- fitDTU(
#'     object = sumExp_example,
#'     formula = ~ 0 + group,
#'     parallel = FALSE,
#'     BPPARAM = BiocParallel::bpparam(),
#'     verbose = TRUE
#' )
#' group <- as.factor(colData(sumExp)$group)
#' design <- model.matrix(~ 0 + group)
#' colnames(design) <- levels(group)
#' L <- matrix(0, ncol = 2, nrow = ncol(design))
#' rownames(L) <- colnames(design)
#' colnames(L) <- c("Contrast1", "Contrast2")
#' L[c("VISp.L5_IT_VISp_Hsd11b1_Endou", "ALM.L5_IT_ALM_Tnc"), 1] <- c(1, -1)
#' L[c("VISp.L5_IT_VISp_Hsd11b1_Endou", 
#'     "ALM.L5_IT_ALM_Tmem163_Dmrtb1"), 2] <- c(1, -1)
#'
#' sumExp <- testDTU(object = sumExp, 
#'     contrasts = L, 
#'     diagplot1 = FALSE,
#'     diagplot2 = FALSE,
#'     sort = FALSE)
#'
#' group1 <- rownames(colData(sumExp))[colData(sumExp)$group == 
#'                                     "VISp.L5_IT_VISp_Hsd11b1_Endou"]
#' group2 <- rownames(colData(sumExp))[colData(sumExp)$group == 
#'                                     "ALM.L5_IT_ALM_Tnc"]
#'
#' plots <- plotDTU(
#'     object = sumExp,
#'     contrast = "Contrast1",
#'     groups = list(group1, group2),
#'     coefficients = list(c(0, 0, 1), c(0, 1, 0)),
#'     summaryStat = "model",
#'     transcripts = c("ENSMUST00000165123", 
#'                     "ENSMUST00000165721", 
#'                     "ENSMUST00000005067"),
#'     genes = NULL,
#'     top.n = 6
#' )
#' @return A ggplot object that can be directly displayed in the current R 
#' session or stored in a list.
#'
#' @rdname plotDTU
#'
#' @author Jeroen Gilis
#'
#' @import ggplot2
#' @importFrom boot inv.logit
#' @importFrom Matrix Matrix
#' @importFrom stats median
#' @importFrom methods is
#' @importFrom SummarizedExperiment colData
#'
#' @export

# Wrapper function, sanity checks and 
# getting all transcripts + the requested contrast in place
plotDTU <- function(object, contrast, groups, coefficients, 
                    summaryStat = "model", transcripts = NULL, genes = NULL, 
                    top.n = 6) {

    ## Stop if some input is not provided or not in the correct format
    stopifnot(is(object, "SummarizedExperiment"))
    stopifnot(class(transcripts) %in% c("character", "NULL"))
    stopifnot(class(genes) %in% c("character", "NULL"))
    stopifnot(class(top.n) %in% c("numeric"))
    if (is.null(rowData(object)[["fitDTUModels"]])) {
        stop("fitDTUModels is empty. Did you run fitDTU first?")
    }
    if (!any(grepl("fitDTUResult", names(rowData(object))))) {
        stop("fitDTUResult is empty. Did you run testDTU first?")
    }
    
    # select the requested contrast
    topTable <- rowData(object)[[paste0("fitDTUResult_", contrast)]] 
    topTable <- topTable[order(topTable$empirical_pval), ]

    tx2gene <- data.frame(cbind(rowData(object)[["isoform_id"]], 
                                rowData(object)[["gene_id"]]))
    colnames(tx2gene) <- c("isoform_id", "gene_id")
    tx2gene$isoform_id <- as.character(tx2gene$isoform_id)
    tx2gene$gene_id <- as.character(tx2gene$gene_id)

    # If both transcripts and genes are null, 
    # plot the top n DTU transcripts (default = 6)
    if (is.null(transcripts) & is.null(genes)) {
        transcripts <- rownames(topTable)[seq_len(top.n)]
        return(plotDTU_internal(object, topTable, contrast, coefficients, 
                                groups, summaryStat, tx2gene, transcripts))
    }

    tx_tx <- tx_gene <- c()

    # If transcripts is not null
    if (!is.null(transcripts)) {
        # handle faulty transcript requests
        absent <- transcripts[!transcripts %in% rownames(topTable)]
        if(length(absent) > 0) {
            warning("The requested transcript \n", 
                    absent, 
                    "\nis not present in the provided topTable. \n\n")
        }
        tx_tx <- transcripts[!transcripts %in% absent]
        
        # handle transcripts with fitError
        NAs <- transcripts[which(is.na(topTable[tx_tx,"empirical_pval"]))]
        if(length(NAs) > 0){
            warning("The requested transcript \n",
                    NAs,
                    "\n has NA results. \n\n")
        }
        tx_tx <- tx_tx[!tx_tx %in% NAs]
    }
    
    # If genes is not null
    if (!is.null(genes)) {
        # handle faulty gene requests
        absent <- NULL
        absent <- genes[!genes %in% tx2gene$gene_id]
        if (length(absent) > 0) {
            warning("The requested gene \n", 
                    absent, 
                    "\nis not present in the provided tx2gene dataframe. \n\n")
        }
        genes <- genes[!genes %in% absent]
        tx_gene <- tx2gene[tx2gene$gene_id %in% genes, "isoform_id"]
        
        # handle transcripts with fitError
        NAs <- transcripts[which(is.na(topTable[tx_gene,"empirical_pval"]))]
        if(length(NAs) > 0){
            warning("The requested transcript \n",
                    NAs,
                    "\n has NA results. \n\n")
        }
        tx_gene <- tx_gene[!tx_gene %in% NAs]
    }
    transcripts <- c(tx_tx, tx_gene)

    if (length(transcripts) < 1) {
        stop("The requested transcripts/genes could not be retrieved 
             from the provided data or had NA results. ")
    }

    # got to the internal visualization function
    plotList <- plotDTU_internal(object, topTable, contrast, coefficients, 
                                groups, summaryStat, tx2gene, transcripts)
    return(plotList)
}

# Compute the dispersion parameter of the quasi-binomial GLM
.calcDispersion <- function(model, type) {
    model$dispersion <- NA
    df.r <- model$df.residual
    if (df.r > 0) {
        model$dispersion <- sum(
            (model$weights * model$residuals^2)[model$weights > 0]) / df.r
    }
    return(model)
}

# Compute the unscaled variance-covariance matrix of the quasi-binomial GLM
.calcVcovUnscaled <- function(model, type) {
    p1 <- 1L:model$rank
    p <- length(model$coef)
    out <- matrix(NA, p, p)
    out[!is.na(model$coefficients), !is.na(model$coefficients)] <- chol2inv(model$qr$qr[p1, p1, drop = FALSE])
    colnames(out) <- rownames(out) <- names(model$coefficients)
    model$vcovUnsc <- out
    return(model)
}

# Computes the "other count" for all in each sample or cell in the data.
# Essentially taking the sum of the counts for each of the transcripts within 
# a gene except the target transcript. Can be thought as the difference between 
# the gene-level count and current transcript-level count.
.getOtherCount <- function(countData, tx2gene) {
    # get tx2gene in better format
    geneForEachTx <- tx2gene$gene_id[match(rownames(countData), 
                                            tx2gene$isoform_id)]
    geneForEachTx <- as.character(geneForEachTx)
    stopifnot(class(geneForEachTx) %in% c("character", "factor"))
    stopifnot(length(geneForEachTx) == nrow(countData))

    forCycle <- split(seq_len(nrow(countData)), as.character(geneForEachTx))
    all <- lapply(forCycle, function(i) {
        sct <- countData[i, , drop = FALSE]
        rs <- t(vapply(seq_len(nrow(sct)), function(r) 
            colSums(sct[-r, , drop = FALSE]), numeric(ncol(countData))))
        rownames(rs) <- rownames(sct)
        rs
    })

    otherCount <- do.call(rbind, all)
    otherCount <- otherCount[rownames(countData), ]
    return(otherCount)
}

# Worker function that fits quasi-binomial models, 
# wrapped inside the fitDTU function
.fitDTU_internal <- function(countData, 
                             tx2gene, 
                             design, 
                             parallel, 
                             BPPARAM, 
                             verbose) {
  if (parallel) {
    BiocParallel::register(BPPARAM)
    if (verbose) {
      # update progress bar 40 times
      BPPARAM$tasks <- as.integer(40)
      # show progress bar
      BPPARAM$progressbar <- TRUE
    }
  }
  
  stopifnot(class(countData)[1] %in% c("matrix", 
                                       "data.frame", 
                                       "dgCMatrix", 
                                       "DelayedMatrix"))
  countData <- as.matrix(countData)
  
  # Get the "other" counts, i.e. the counts for all other transcripts 
  # belonging to the same gene as the current transcript
  otherCount <- .getOtherCount(countData, tx2gene)
  stopifnot(all(rownames(countData) %in% rownames(otherCount)))
  
  # Check if lonely transcripts (only transcript in its corresponding gene)
  # have already been removed, if not throw message
  lonely_tx <- !tx2gene$gene_id %in% tx2gene$gene_id[duplicated(tx2gene$gene_id)]
  if(any(lonely_tx)){
    message("Genes with only one type of transcript/isoform detected. 
            Results of such transcripts will be set to NA and flagged as
            lonelyTranscript.")
  }
  
  # The actual fit function
  fitQuasiLogistic <- function(countData, otherCount, design, lonely_txi) {
    
    # if the transcript is the only transcript in its corresponding gene
    # return empty model
    if(lonely_txi){
      .out <- .StatModel(
        type = "lonelyTranscript",
        params = list(coefficients = NA, 
                      df.residual = NA,
                      dispersion = NA,
                      vcovUnsc = NA),
        varPosterior = as.numeric(NA),
        dfPosterior = as.numeric(NA)
      )
      return(.out)
    }
    
    countsAll <- cbind(countData, otherCount)
    drop <- rowSums(countsAll) == 0 ## gene count is zero in this cell
    countsAll <- countsAll + 1
    countsAll[drop, ] <- NA
    
    model <- try(glm(countsAll ~ -1 + design, family = "quasibinomial"))
    
    # if the quasibinomial model could not be estimated
    # return empty model
    if (class(model)[1] == "try-error") {
      .out <- .StatModel(
        type = "fitError",
        params = list(coefficients = NA, 
                      df.residual = NA,
                      dispersion = NA,
                      vcovUnsc = NA),
        varPosterior = as.numeric(NA),
        dfPosterior = as.numeric(NA)
      )
      return(.out)
    } else {
      type <- "glm"
      class(model) <- "list"
    }
    
    model <- .calcDispersion(model, type) ## calculate disp slot
    model <- .calcVcovUnscaled(model, type) ## calculate vcov slot
    
    model <- model[c("coefficients", 
                     "df.residual", 
                     "dispersion", 
                     "vcovUnsc")]
    
    .out <- .StatModel(
      type = type,
      params = model,
      varPosterior = as.numeric(NA),
      dfPosterior = as.numeric(NA)
    )
    return(.out)
  }
  
  # Fit the models
  if (parallel) {
    models <- BiocParallel::bplapply(seq_len(nrow(countData)), function(i) 
      fitQuasiLogistic(countData = countData[i, ], 
                       otherCount = otherCount[i, ], 
                       design = design,
                       lonely_txi = lonely_tx[i]), 
      BPPARAM = BPPARAM)
  } else {
    if (verbose) {
      models <- pbapply::pblapply(seq_len(nrow(countData)), function(i) 
        fitQuasiLogistic(countData = countData[i, ], 
                         otherCount = otherCount[i, ], 
                         design = design,
                         lonely_txi = lonely_tx[i]))
    } else {
      models <- lapply(seq_len(nrow(countData)), function(i) 
        fitQuasiLogistic(countData = countData[i, ], 
                         otherCount = otherCount[i, ], 
                         design = design,
                         lonely_txi = lonely_tx[i]))
    }
  }
  
  # retain transcript names
  names(models) <- rownames(countData)
  
  # Squeeze a set of sample variances together 
  # by computing empirical Bayes posterior means
  hlp <- limma::squeezeVar(
    var = unlist(vapply(models, getDispersion, numeric(1))),
    df = unlist(vapply(models, getDF, numeric(1))),
    robust = FALSE
  )
  
  # put variance and degrees of freedom in appropriate slots
  for (i in seq_along(models)) {
    mydf <- hlp$df.prior + getDF(models[[i]])
    models[[i]]@varPosterior <- as.numeric(hlp$var.post[i])
    models[[i]]@dfPosterior <- as.numeric(mydf)
  }
  
  # return object of class StatModel
  return(models)
}

#' Function to fit quasi-binomial models
#'
#' @description Parameter estimation of quasi-binomial models.
#'
#' @param object A `SummarizedExperiment` instance generated with the
#' SummarizedExperiment function of the SummarizedExperiment package.
#' In the assay slot, provide the transcript-level expression counts as an
#' ordinary `matrix`, `DataFrame`, a `sparseMatrix` or a `DelayedMatrix`.
#' The `rowData` slot must be a `DataFrame` object describing the rows,
#' which must contain a column `isoform_id` with the row names of
#' the expression matrix and a column `gene_id` with the corresponding gene
#' identifiers of each transcript. `colData` is a `DataFrame` describing
#' the samples or cells in the experiment. Finally, specify the
#' experimental design as a formula in the metadata slot. This formula must
#' be based on the colData. See the documentation examples and the vignette
#' for more details.
#'
#' @param formula Model formula. The model is built based on the
#' covariates in the data object.
#'
#' @param parallel Logical, defaults to FALSE. Set to TRUE if you want to
#' parallellize the fitting procedure.
#'
#' @param BPPARAM object of class \code{bpparamClass} that specifies the
#' back-end to be used for computations. See
#' \code{bpparam} in \code{BiocParallel} package for details.
#'
#' @param verbose Logical, should progress be printed?
#'
#' @examples
#' data(sumExp_example, package = "satuRn")
#' sumExp <- fitDTU(
#'     object = sumExp_example,
#'     formula = ~ 0 + group,
#'     parallel = FALSE,
#'     BPPARAM = BiocParallel::bpparam(),
#'     verbose = TRUE
#' )
#' @return An updated `SummarizedExperiment` instance. The instance now includes
#'     a new list of models ("fitDTUModels") in its rowData slot,
#'     which can be accessed by rowData(object)[["fitDTUModels"]].
#'
#' @rdname fitDTU
#'
#' @author Jeroen Gilis
#'
#' @import SummarizedExperiment
#' @importFrom limma squeezeVar
#' @importFrom stats model.matrix
#' @importFrom BiocParallel register
#' @importFrom BiocParallel bplapply
#' @importFrom pbapply pblapply
#'
#' @export

# Wrapper function
setMethod(
    f = "fitDTU",
    signature = "SummarizedExperiment",
    function(object,
    formula,
    parallel = FALSE,
    BPPARAM = BiocParallel::bpparam(),
    verbose = TRUE) {
        if (ncol(SummarizedExperiment::colData(object)) == 0) 
            stop("colData is empty")

        design <- model.matrix(formula, SummarizedExperiment::colData(object))

        if (!"gene_id" %in% colnames(rowData(object)) | 
            !"isoform_id" %in% colnames(rowData(object))) {
            stop("rowData does not contain columns gene_id and isoform_id")
        }
        if (!all(rownames(object) == rowData(object)[, "isoform_id"])) {
            stop("not all row names of the expression matrix match 
                the isoform_id column of the object's rowData")
        }

        rowData(object)[["fitDTUModels"]] <- .fitDTU_internal(
            countData = assay(object),
            tx2gene = rowData(object)[, c("isoform_id", "gene_id")],
            design = design,
            parallel = parallel,
            BPPARAM = BPPARAM,
            verbose = verbose
        )

        return(object)
    }
)

## ----echo = FALSE-------------------------------------------------------------
library(knitr)

## ----eval=FALSE---------------------------------------------------------------
# if(!requireNamespace("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# BiocManager::install("satuRn")

## ----eval=FALSE---------------------------------------------------------------
# devtools::install_github("statOmics/satuRn")

## ----message=FALSE, warning=FALSE---------------------------------------------
library(satuRn)
library(AnnotationHub)
library(ensembldb)
library(edgeR)
library(SummarizedExperiment)
library(ggplot2)
library(DEXSeq)
library(stageR)

## -----------------------------------------------------------------------------
data(Tasic_counts_vignette) # transcript expression matrix
data(Tasic_metadata_vignette) # metadata

## ----message=FALSE, warning=FALSE---------------------------------------------
ah <- AnnotationHub() # load the annotation resource.
all <- query(ah, "EnsDb") # query for all available EnsDb databases
ahEdb <- all[["AH75036"]] # for Mus musculus (choose correct release date)
txs <- transcripts(ahEdb)

## -----------------------------------------------------------------------------
# Get the transcript information in correct format
txInfo <- as.data.frame(matrix(data = NA, nrow = length(txs), ncol = 2))
colnames(txInfo) <- c("isoform_id", "gene_id")
txInfo$isoform_id <- txs$tx_id
txInfo$gene_id <- txs$gene_id
rownames(txInfo) <- txInfo$isoform_id

# Remove transcripts that are the only isoform expressed of a certain gene
rownames(Tasic_counts_vignette) <- sub("\\..*", "", 
                                       rownames(Tasic_counts_vignette)) 
# remove transcript version identifiers

txInfo <- txInfo[txInfo$isoform_id %in% rownames(Tasic_counts_vignette), ]
txInfo <- subset(txInfo, 
                 duplicated(gene_id) | duplicated(gene_id, fromLast = TRUE))

Tasic_counts_vignette <- Tasic_counts_vignette[which(
  rownames(Tasic_counts_vignette) %in% txInfo$isoform_id), ]

## -----------------------------------------------------------------------------
filter_edgeR <- filterByExpr(Tasic_counts_vignette,
    design = NULL,
    group = Tasic_metadata_vignette$brain_region,
    lib.size = NULL,
    min.count = 10,
    min.total.count = 30,
    large.n = 20,
    min.prop = 0.7
) # more stringent than default to reduce run time of the vignette

table(filter_edgeR)
Tasic_counts_vignette <- Tasic_counts_vignette[filter_edgeR, ]

# Update txInfo according to the filtering procedure
txInfo <- txInfo[which(
  txInfo$isoform_id %in% rownames(Tasic_counts_vignette)), ]

# remove txs that are the only isoform expressed within a gene (after filtering)
txInfo <- subset(txInfo, 
                 duplicated(gene_id) | duplicated(gene_id, fromLast = TRUE))
Tasic_counts_vignette <- Tasic_counts_vignette[which(rownames(
  Tasic_counts_vignette) %in% txInfo$isoform_id), ]

# satuRn requires the transcripts in the rowData and 
# the transcripts in the count matrix to be in the same order.
txInfo <- txInfo[match(rownames(Tasic_counts_vignette), txInfo$isoform_id), ]

## -----------------------------------------------------------------------------
Tasic_metadata_vignette$group <- paste(Tasic_metadata_vignette$brain_region, 
                                       Tasic_metadata_vignette$cluster, 
                                       sep = ".")

## ----message=FALSE------------------------------------------------------------
sumExp <- SummarizedExperiment::SummarizedExperiment(
    assays = list(counts = Tasic_counts_vignette),
    colData = Tasic_metadata_vignette,
    rowData = txInfo
)

# for sake of completeness: specify design formula from colData
metadata(sumExp)$formula <- ~ 0 + as.factor(colData(sumExp)$group)
sumExp

## -----------------------------------------------------------------------------
system.time({
sumExp <- satuRn::fitDTU(
    object = sumExp,
    formula = ~ 0 + group,
    parallel = FALSE,
    BPPARAM = BiocParallel::bpparam(),
    verbose = TRUE
)
})

## -----------------------------------------------------------------------------
rowData(sumExp)[["fitDTUModels"]]$"ENSMUST00000037739"

## -----------------------------------------------------------------------------
group <- as.factor(Tasic_metadata_vignette$group)
design <- model.matrix(~ 0 + group) # construct design matrix
colnames(design) <- levels(group)

L <- matrix(0, ncol = 2, nrow = ncol(design)) # initialize contrast matrix
rownames(L) <- colnames(design)
colnames(L) <- c("Contrast1", "Contrast2")

L[c("VISp.L5_IT_VISp_Hsd11b1_Endou","ALM.L5_IT_ALM_Tnc"),1] <-c(1,-1)
L[c("VISp.L5_IT_VISp_Hsd11b1_Endou","ALM.L5_IT_ALM_Tmem163_Dmrtb1"),2] <-c(1,-1)
L # contrast matrix

## -----------------------------------------------------------------------------
group <- as.factor(Tasic_metadata_vignette$group)
design <- model.matrix(~ 0 + group) # construct design matrix
colnames(design) <- levels(group)

L <- limma::makeContrasts(
    Contrast1 = VISp.L5_IT_VISp_Hsd11b1_Endou - ALM.L5_IT_ALM_Tnc,
    Contrast2 = VISp.L5_IT_VISp_Hsd11b1_Endou - ALM.L5_IT_ALM_Tmem163_Dmrtb1,
    levels = design
)
L # contrast matrix

## -----------------------------------------------------------------------------
sumExp <- satuRn::testDTU(
    object = sumExp,
    contrasts = L,
    diagplot1 = TRUE,
    diagplot2 = TRUE,
    sort = FALSE
)

## -----------------------------------------------------------------------------
head(rowData(sumExp)[["fitDTUResult_Contrast1"]]) # first contrast

## -----------------------------------------------------------------------------
head(rowData(sumExp)[["fitDTUResult_Contrast2"]]) # second contrast

## ----warning=FALSE------------------------------------------------------------
group1 <- colnames(sumExp)[colData(sumExp)$group == 
                             "VISp.L5_IT_VISp_Hsd11b1_Endou"]
group2 <- colnames(sumExp)[colData(sumExp)$group == 
                             "ALM.L5_IT_ALM_Tnc"]

plots <- satuRn::plotDTU(
    object = sumExp,
    contrast = "Contrast1",
    groups = list(group1, group2),
    coefficients = list(c(0, 0, 1), c(0, 1, 0)),
    summaryStat = "model",
    transcripts = c("ENSMUST00000081554", 
                    "ENSMUST00000195963", 
                    "ENSMUST00000132062"),
    genes = NULL,
    top.n = 6
)

# to have same layout as in our paper
for (i in seq_along(plots)) {
    current_plot <- plots[[i]] +
        scale_fill_manual(labels = c("VISp", "ALM"), values = c("royalblue4", 
                                                                "firebrick")) +
        scale_x_discrete(labels = c("Hsd11b1_Endou", "Tnc"))

    print(current_plot)
}

## ----stage-wise testing-------------------------------------------------------
# transcript level p-values from satuRn
pvals <- rowData(sumExp)[["fitDTUResult_Contrast1"]]$empirical_pval

# compute gene level q-values
geneID <- factor(rowData(sumExp)$gene_id)
geneSplit <- split(seq(along = geneID), geneID)
pGene <- sapply(geneSplit, function(i) min(pvals[i]))
pGene[is.na(pGene)] <- 1
theta <- unique(sort(pGene))

# gene-level significance testing
q <- DEXSeq:::perGeneQValueExact(pGene, theta, geneSplit) 
qScreen <- rep(NA_real_, length(pGene))
qScreen <- q[match(pGene, theta)]
qScreen <- pmin(1, qScreen)
names(qScreen) <- names(geneSplit)

# prepare stageR input
tx2gene <- as.data.frame(rowData(sumExp)[c("isoform_id", "gene_id")])
colnames(tx2gene) <- c("transcript", "gene")

pConfirmation <- matrix(matrix(pvals),
    ncol = 1,
    dimnames = list(rownames(tx2gene), "transcript")
)

# create a stageRTx object
stageRObj <- stageR::stageRTx(
    pScreen = qScreen,
    pConfirmation = pConfirmation,
    pScreenAdjusted = TRUE,
    tx2gene = tx2gene
)

# perform the two-stage testing procedure
stageRObj <- stageR::stageWiseAdjustment(
    object = stageRObj,
    method = "dtu",
    alpha = 0.05,
    allowNA = TRUE
)

# retrieves the adjusted p-values from the stageRTx object
padj <- stageR::getAdjustedPValues(stageRObj,
    order = TRUE,
    onlySignificantGenes = FALSE
)
head(padj)

## -----------------------------------------------------------------------------
sessionInfo()

---
title: 'satuRn - vignette'
author: "Jeroen Gilis"
bibliography: satuRn.bib
date: "14/07/2022"
output: 
  rmarkdown::html_document:
    toc: true
    toc_depth: 3
vignette: >
  %\VignetteIndexEntry{satuRn - vignette}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, echo = FALSE}
library(knitr)
```

# Introduction

`satuRn` is an R package for performing differential transcript usage analyses 
in bulk and single-cell transcriptomics datasets. 
The package has three main functions. 

1. The first function, `fitDTU`, is used to model transcript usage profiles by 
means of a quasi-binomial generalized linear model. 

2. Second, the `testDTU` function tests for differential usage of transcripts
between certain groups of interest (e.g. different treatment groups or
cell types). 

3. Finally, the `plotDTU` can be used to visualize the usage profiles of 
selected transcripts in different groups of interest. 

All details about the `satuRn` model and statistical tests are described 
in our preprint [@Gilis2021].

In this vignette, we analyze a small subset of the data from [@Tasic2018]. 
More specifically, an expression matrix and the corresponding metadata of 
the  subset data has been provided with the `satuRn` package. We will adopt 
this dataset to showcase the different functionalities of `satuRn`.

# Package installation

`satuRn` (version 1.4.0) can be installed from Bioconductor with:

```{r, eval=FALSE}
if(!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("satuRn")
```

Alternatively, the development version of `satuRn` can be downloaded with:
 
```{r, eval=FALSE}
devtools::install_github("statOmics/satuRn")
```

*! for this vignette, we use the development version of satuRn.*
The vignette for the officially released satuRn version 1.4.0 can be viewed from 
[Bioconductor](https://bioconductor.org/packages/release/bioc/vignettes/satuRn/inst/doc/Vignette.html)

# Load libraries

```{r, message=FALSE, warning=FALSE}
library(satuRn)
library(AnnotationHub)
library(ensembldb)
library(edgeR)
library(SummarizedExperiment)
library(ggplot2)
library(DEXSeq)
library(stageR)
```

# Load data

The following data corresponds to a small subset of the dataset 
from [@Tasic2018] and is readily available from the `satuRn` package.
To check how the subset was generate, please check `?Tasic_counts_vignette`.

```{r}
data(Tasic_counts_vignette) # transcript expression matrix
data(Tasic_metadata_vignette) # metadata
```

# Data pre-processing

We start the analysis from scratch, in order to additionally showcase some of
the prerequisite steps for performing a DTU analysis.

# Import transcript information

First, we need an object that links transcripts to their corresponding genes. 
We suggest using the BioConductor R packages `AnnotationHub` and `ensembldb` 
for this purpose.  

```{r, message=FALSE, warning=FALSE}
ah <- AnnotationHub() # load the annotation resource.
all <- query(ah, "EnsDb") # query for all available EnsDb databases
ahEdb <- all[["AH75036"]] # for Mus musculus (choose correct release date)
txs <- transcripts(ahEdb)
```

## Data wrangling

Next, we perform some data wrangling steps to get the data in a format that is
suited for satuRn. First, we create a `DataFrame` or `Matrix` linking 
transcripts to their corresponding genes.

! Important: `satuRn` is implemented such that the columns with transcript 
identifiers is names `isoform_id`, while the column containing gene identifiers 
should be named `gene_id`. In addition, following chunk removes transcripts 
that are the only isoform expressed of a certain gene, as they cannot be used 
in a DTU analysis.

```{r}
# Get the transcript information in correct format
txInfo <- as.data.frame(matrix(data = NA, nrow = length(txs), ncol = 2))
colnames(txInfo) <- c("isoform_id", "gene_id")
txInfo$isoform_id <- txs$tx_id
txInfo$gene_id <- txs$gene_id
rownames(txInfo) <- txInfo$isoform_id

# Remove transcripts that are the only isoform expressed of a certain gene
rownames(Tasic_counts_vignette) <- sub("\\..*", "", 
                                       rownames(Tasic_counts_vignette)) 
# remove transcript version identifiers

txInfo <- txInfo[txInfo$isoform_id %in% rownames(Tasic_counts_vignette), ]
txInfo <- subset(txInfo, 
                 duplicated(gene_id) | duplicated(gene_id, fromLast = TRUE))

Tasic_counts_vignette <- Tasic_counts_vignette[which(
  rownames(Tasic_counts_vignette) %in% txInfo$isoform_id), ]
```

## Filtering

Here we perform some feature-level filtering. For this task, we adopt 
the filtering criterion that is implemented in the R package `edgeR`. 
Alternatively, one could adopt the `dmFilter` criterion from the `DRIMSeq` R 
package, which provides a more stringent filtering when both methods are run 
in default settings. After filtering, we again remove transcripts that are 
the only isoform expressed of a certain gene.

```{r}
filter_edgeR <- filterByExpr(Tasic_counts_vignette,
    design = NULL,
    group = Tasic_metadata_vignette$brain_region,
    lib.size = NULL,
    min.count = 10,
    min.total.count = 30,
    large.n = 20,
    min.prop = 0.7
) # more stringent than default to reduce run time of the vignette

table(filter_edgeR)
Tasic_counts_vignette <- Tasic_counts_vignette[filter_edgeR, ]

# Update txInfo according to the filtering procedure
txInfo <- txInfo[which(
  txInfo$isoform_id %in% rownames(Tasic_counts_vignette)), ]

# remove txs that are the only isoform expressed within a gene (after filtering)
txInfo <- subset(txInfo, 
                 duplicated(gene_id) | duplicated(gene_id, fromLast = TRUE))
Tasic_counts_vignette <- Tasic_counts_vignette[which(rownames(
  Tasic_counts_vignette) %in% txInfo$isoform_id), ]

# satuRn requires the transcripts in the rowData and 
# the transcripts in the count matrix to be in the same order.
txInfo <- txInfo[match(rownames(Tasic_counts_vignette), txInfo$isoform_id), ]
```

## Create a design matrix

Here we set up the design matrix of the experiment. The subset of the dataset 
from [@Tasic2018] contains cells of several different cell types 
(variable `cluster`) in two different areas of the mouse neocortex 
(variable `brain_region`). As such, we can model the data with 
a factorial design, i.e. by generating a new variable `group` that encompasses 
all different cell type - brain region combinations. 

```{r}
Tasic_metadata_vignette$group <- paste(Tasic_metadata_vignette$brain_region, 
                                       Tasic_metadata_vignette$cluster, 
                                       sep = ".")
```

## Generate SummarizedExperiment

All three main functions of `satuRn` require a `SummarizedExperiment` object as 
an input class. See the SummarizedExperiment vignette [@SummarizedExperiment] 
for more information on this object class.  

For the sake of completeness, it is advised to include the design matrix formula 
in the SummarizedExperiment as indicated below.

```{r, message=FALSE}
sumExp <- SummarizedExperiment::SummarizedExperiment(
    assays = list(counts = Tasic_counts_vignette),
    colData = Tasic_metadata_vignette,
    rowData = txInfo
)

# for sake of completeness: specify design formula from colData
metadata(sumExp)$formula <- ~ 0 + as.factor(colData(sumExp)$group)
sumExp
```

# Fit quasi-binomial generalized linear models models

The `fitDTU` function of `satuRn` is used to model transcript usage in different
groups of samples or cells. Here we adopt the default settings of the function.
Without parallelized execution, this code runs for approximately 15 seconds 
on a 2018 macbook pro laptop. 

```{r}
system.time({
sumExp <- satuRn::fitDTU(
    object = sumExp,
    formula = ~ 0 + group,
    parallel = FALSE,
    BPPARAM = BiocParallel::bpparam(),
    verbose = TRUE
)
})
```

The resulting model fits are now saved into the `rowData` of 
our SummarizedExperiment object under the name `fitDTUModels`. 
These models can be accessed as follows:

```{r}
rowData(sumExp)[["fitDTUModels"]]$"ENSMUST00000037739"
```

The models are instances of the `StatModel` class as defined in 
the `satuRn` package. These contain all relevant information for 
the downstream analysis. For more details, read the StatModel documentation 
with ?satuRn::`StatModel-class`.

# Test for DTU

Here we test for differential transcript usage between select groups 
of interest. In this example, the groups of interest are the three different 
cell types that are present in the dataset associated with this vignette.

## Set up contrast matrix

First, we set up a contrast matrix. This allows us to test for differential 
transcript usage between groups of interest. The `group` factor in this 
toy example contains three levels; (1) ALM.L5_IT_ALM_Tmem163_Dmrtb1, 
(2) ALM.L5_IT_ALM_Tnc, (3) VISp.L5_IT_VISp_Hsd11b1_Endou. 
Here we show to assess DTU between cells of the groups 1 and 3
and between cells of groups 2 and 3.

The contrast matrix can be constructed manually;

```{r}
group <- as.factor(Tasic_metadata_vignette$group)
design <- model.matrix(~ 0 + group) # construct design matrix
colnames(design) <- levels(group)

L <- matrix(0, ncol = 2, nrow = ncol(design)) # initialize contrast matrix
rownames(L) <- colnames(design)
colnames(L) <- c("Contrast1", "Contrast2")

L[c("VISp.L5_IT_VISp_Hsd11b1_Endou","ALM.L5_IT_ALM_Tnc"),1] <-c(1,-1)
L[c("VISp.L5_IT_VISp_Hsd11b1_Endou","ALM.L5_IT_ALM_Tmem163_Dmrtb1"),2] <-c(1,-1)
L # contrast matrix
```

This can also be done automatically with the `makeContrasts` function of 
the `limma` R package.

```{r}
group <- as.factor(Tasic_metadata_vignette$group)
design <- model.matrix(~ 0 + group) # construct design matrix
colnames(design) <- levels(group)

L <- limma::makeContrasts(
    Contrast1 = VISp.L5_IT_VISp_Hsd11b1_Endou - ALM.L5_IT_ALM_Tnc,
    Contrast2 = VISp.L5_IT_VISp_Hsd11b1_Endou - ALM.L5_IT_ALM_Tmem163_Dmrtb1,
    levels = design
)
L # contrast matrix
```

## Perform the test

Next we can perform differential usage testing using `testDTU`. We again adopt 
default settings. For more information on the parameter settings, please consult
the help file of the `testDTU` function. Note that the arguments `diagplot1` and
`diagplot2` were not yet implemented in `satuRn` v1.1.1.

```{r}
sumExp <- satuRn::testDTU(
    object = sumExp,
    contrasts = L,
    diagplot1 = TRUE,
    diagplot2 = TRUE,
    sort = FALSE
)
```

When set to TRUE, the `diagplot1` and `diagplot2` arguments generate a 
diagnostic plot.

For `diagplot1`, the histogram of the z-scores (computed from p-values) is 
displayed using the locfdr function of the `locfdr` package. The blue dashed 
curve is fitted to the mid 50% of the z-scores, which are assumed to originate 
from null transcripts, thus representing the estimated empirical null component 
densities. The maximum likelihood estimates (MLE) and central matching estimates 
(CME) of this estimated empirical null distribution are given below the plot. 
If the MLE estimates for delta and sigma deviate from 0 and 1 respectively, the 
downstream inference will be influenced by the empirical adjustment implemented 
in satuRn (see below).

For `diagplot2`, a plot of the histogram of the "empirically adjusted" test 
statistics and the standard normal distribution will be displayed. Ideally, 
the majority (mid portion) of the adjusted test statistics should follow 
the standard normal. If this is not the case, the inference may be 
untrustworthy and results should be treated with care. One potential solution
is to include (additional) potential covariates in the analysis.

The test results are now saved into the `rowData` of our SummarizedExperiment 
object under the name `fitDTUResult_` followed by the name of the contrast 
of interest (i.e. the column names of the contrast matrix). 
The results can be accessed as follows:

```{r}
head(rowData(sumExp)[["fitDTUResult_Contrast1"]]) # first contrast
```

```{r}
head(rowData(sumExp)[["fitDTUResult_Contrast2"]]) # second contrast
```

The results for are, for each contrast, a dataframe with 8 columns:

- `estimates`: The estimated log-odds ratios (log base e). In the most simple 
case, an estimate of +1 would mean that the odds of picking that transcript from 
the pool of transcripts within its corresponding gene is exp(1) = 2.72 times 
larger in condition B than in condition A.
- `se`: The standard error on this estimate.
- `df`: The posterior degrees of freedom for the test statistic.
- `t`: The student's t-test statistic, computed with a Wald test given
`estimates` and `se`.
- `pval`: The "raw" p-value given `t` and `df`.
- `FDR`: The false discovery rate, computed using the multiple testing 
correction of Benjamini and Hochberg on `pval`.
- `empirical_pval`: An "empirical" p-value that is computed by estimating the 
null distribution of the test statistic empirically. For more details, see our 
publication.
- `empirical_FDR`: The false discovery rate, computed using the multiple testing 
correction of Benjamini and Hochberg on `pval_empirical`.

**!Note: based on the benchmarks in our publication, we always recommend using**
**the empirical p-values from column 7 over the "raw" p-value from column 5.**
When the MLE estimates for the mean and standard deviation (delta and sigma) of
the empirical null density (blue dashed curve in `diagplot1`) deviate from 0 and
1 respectively, there will be a discrepancy between the "raw" and "empirically
adjusted" p-values. A deviation in the standard deviation only affects the 
magnitude of the p-values, whereas a deviation in the mean also affects the
ranking of transcripts according to their p-value.

# Visualize DTU

Finally, we may visualize the usage of select transcripts in select groups 
of interest.

```{r, warning=FALSE}
group1 <- colnames(sumExp)[colData(sumExp)$group == 
                             "VISp.L5_IT_VISp_Hsd11b1_Endou"]
group2 <- colnames(sumExp)[colData(sumExp)$group == 
                             "ALM.L5_IT_ALM_Tnc"]

plots <- satuRn::plotDTU(
    object = sumExp,
    contrast = "Contrast1",
    groups = list(group1, group2),
    coefficients = list(c(0, 0, 1), c(0, 1, 0)),
    summaryStat = "model",
    transcripts = c("ENSMUST00000081554", 
                    "ENSMUST00000195963", 
                    "ENSMUST00000132062"),
    genes = NULL,
    top.n = 6
)

# to have same layout as in our paper
for (i in seq_along(plots)) {
    current_plot <- plots[[i]] +
        scale_fill_manual(labels = c("VISp", "ALM"), values = c("royalblue4", 
                                                                "firebrick")) +
        scale_x_discrete(labels = c("Hsd11b1_Endou", "Tnc"))

    print(current_plot)
}
```

# Optional post-processing of results: Two-stage testing procedure with stageR

`satuRn` returns transcript-level p-values for each of the specified contrasts.
While we have shown that `satuRn` is able to adequately control the false 
discovery rate (FDR) at the transcript level [@Gilis2021], 
[@VandenBerge2017] argued that it is often desirable to control the FDR at 
the gene level. This boosts statistical power and eases downstream
biological interpretation and validation, which typically occur at 
the gene level. 

To this end, [@VandenBerge2017] developed a testing procedure that is 
implemented in the BioConductor R package `stageR`. The procedure consists of 
two stages; a screening stage and a confirmation stage. 

In the screening stage, gene-level FDR-adjusted p-values are computed, 
which aggregate the evidence for differential transcript usage over all 
transcripts within the gene. Only genes with an FDR below the desired 
nominal level are further considered in the second stage. 
In the confirmation stage, transcript-level p-values are adjusted for 
those genes, using a FWER-controlling method on the FDR-adjusted 
significance level.

In its current implementation, `stageR` can only perform stage-wise testing if 
only one contrast is of interest in a DTU setting. An analogous correction for 
the assessment of multiple contrasts for multiple transcripts per gene 
has not yet been implemented. 

Below, we demonstrate how the transcript-level p-values for the first contrast 
as returned by `satuRn` can be post-processed using `stageR`. 
We rely on the `perGeneQValue` function:

```{r, stage-wise testing}
# transcript level p-values from satuRn
pvals <- rowData(sumExp)[["fitDTUResult_Contrast1"]]$empirical_pval

# compute gene level q-values
geneID <- factor(rowData(sumExp)$gene_id)
geneSplit <- split(seq(along = geneID), geneID)
pGene <- sapply(geneSplit, function(i) min(pvals[i]))
pGene[is.na(pGene)] <- 1
theta <- unique(sort(pGene))

# gene-level significance testing
q <- DEXSeq:::perGeneQValueExact(pGene, theta, geneSplit) 
qScreen <- rep(NA_real_, length(pGene))
qScreen <- q[match(pGene, theta)]
qScreen <- pmin(1, qScreen)
names(qScreen) <- names(geneSplit)

# prepare stageR input
tx2gene <- as.data.frame(rowData(sumExp)[c("isoform_id", "gene_id")])
colnames(tx2gene) <- c("transcript", "gene")

pConfirmation <- matrix(matrix(pvals),
    ncol = 1,
    dimnames = list(rownames(tx2gene), "transcript")
)

# create a stageRTx object
stageRObj <- stageR::stageRTx(
    pScreen = qScreen,
    pConfirmation = pConfirmation,
    pScreenAdjusted = TRUE,
    tx2gene = tx2gene
)

# perform the two-stage testing procedure
stageRObj <- stageR::stageWiseAdjustment(
    object = stageRObj,
    method = "dtu",
    alpha = 0.05,
    allowNA = TRUE
)

# retrieves the adjusted p-values from the stageRTx object
padj <- stageR::getAdjustedPValues(stageRObj,
    order = TRUE,
    onlySignificantGenes = FALSE
)
head(padj)
```

# Session

```{r}
sessionInfo()
```

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotDTU.R
\name{plotDTU}
\alias{plotDTU}
\title{Plot function to visualize differential transcript usage (DTU)}
\usage{
plotDTU(
  object,
  contrast,
  groups,
  coefficients,
  summaryStat = "model",
  transcripts = NULL,
  genes = NULL,
  top.n = 6
)
}
\arguments{
\item{object}{A `SummarizedExperiment` containing the models and results
of the DTU analysis as obtained by the `fitDTU` and `testDTU` function 
from this `satuRn` package, respectively.}

\item{contrast}{Specifies the specific contrast for which the visualization 
should be returned. This should be one of the column names of 
the contrast matrix that was provided to the `testDTU` function.}

\item{groups}{A `list` containing two character vectors.
Each character vector contains the names (sample names or cell names) 
of the respective groups in the target contrast.}

\item{coefficients}{A `list` containing two numeric vectors. 
Each numeric vector specifies the model coefficient of the corresponding 
groups in the selected contrast.}

\item{summaryStat}{Which summary statistic for the relative usage of 
the transcript should be displayed. `Character` or `character vector`, 
must be any of following summary statistics; model (default), 
mean or median.}

\item{transcripts}{A `character` or `character vector` of transcript IDs,
to specify which transcripts should be visualized. Can be used together 
with `genes`. If not specified, `plotDTU` will check if the `genes` slot 
is specified.}

\item{genes}{A single `character` or `character vector` of gene IDs,
to specify the genes for which the individual transcripts should be 
visualized. Can be used together with `transcripts`. If not specified, 
`plotDTU` will check if the `transcripts` slot is specified.}

\item{top.n}{A `numeric` value. If neither `transcripts` nor `genes` was
was specified, this argument leads to the visualization of the `n` most
significant DTU transcripts in the contrast. Defaults to 6 transcripts.}
}
\value{
A ggplot object that can be directly displayed in the current R 
session or stored in a list.
}
\description{
Plot function to visualize differential transcript usage (DTU)
}
\examples{
data(sumExp_example, package = "satuRn")
library(SummarizedExperiment)
sumExp <- fitDTU(
    object = sumExp_example,
    formula = ~ 0 + group,
    parallel = FALSE,
    BPPARAM = BiocParallel::bpparam(),
    verbose = TRUE
)
group <- as.factor(colData(sumExp)$group)
design <- model.matrix(~ 0 + group)
colnames(design) <- levels(group)
L <- matrix(0, ncol = 2, nrow = ncol(design))
rownames(L) <- colnames(design)
colnames(L) <- c("Contrast1", "Contrast2")
L[c("VISp.L5_IT_VISp_Hsd11b1_Endou", "ALM.L5_IT_ALM_Tnc"), 1] <- c(1, -1)
L[c("VISp.L5_IT_VISp_Hsd11b1_Endou", 
    "ALM.L5_IT_ALM_Tmem163_Dmrtb1"), 2] <- c(1, -1)

sumExp <- testDTU(object = sumExp, 
    contrasts = L, 
    diagplot1 = FALSE,
    diagplot2 = FALSE,
    sort = FALSE)

group1 <- rownames(colData(sumExp))[colData(sumExp)$group == 
                                    "VISp.L5_IT_VISp_Hsd11b1_Endou"]
group2 <- rownames(colData(sumExp))[colData(sumExp)$group == 
                                    "ALM.L5_IT_ALM_Tnc"]

plots <- plotDTU(
    object = sumExp,
    contrast = "Contrast1",
    groups = list(group1, group2),
    coefficients = list(c(0, 0, 1), c(0, 1, 0)),
    summaryStat = "model",
    transcripts = c("ENSMUST00000165123", 
                    "ENSMUST00000165721", 
                    "ENSMUST00000005067"),
    genes = NULL,
    top.n = 6
)
}
\author{
Jeroen Gilis
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allGenerics.R, R/fitDTU.R
\name{fitDTU}
\alias{fitDTU}
\alias{fitDTU,SummarizedExperiment-method}
\title{fitDTU}
\usage{
fitDTU(object, ...)

\S4method{fitDTU}{SummarizedExperiment}(
  object,
  formula,
  parallel = FALSE,
  BPPARAM = BiocParallel::bpparam(),
  verbose = TRUE
)
}
\arguments{
\item{object}{A `SummarizedExperiment` instance generated with the
SummarizedExperiment function of the SummarizedExperiment package.
In the assay slot, provide the transcript-level expression counts as an
ordinary `matrix`, `DataFrame`, a `sparseMatrix` or a `DelayedMatrix`.
The `rowData` slot must be a `DataFrame` object describing the rows,
which must contain a column `isoform_id` with the row names of
the expression matrix and a column `gene_id` with the corresponding gene
identifiers of each transcript. `colData` is a `DataFrame` describing
the samples or cells in the experiment. Finally, specify the
experimental design as a formula in the metadata slot. This formula must
be based on the colData. See the documentation examples and the vignette
for more details.}

\item{...}{parameters including:}

\item{formula}{Model formula. The model is built based on the
covariates in the data object.}

\item{parallel}{Logical, defaults to FALSE. Set to TRUE if you want to
parallellize the fitting procedure.}

\item{BPPARAM}{object of class \code{bpparamClass} that specifies the
back-end to be used for computations. See
\code{bpparam} in \code{BiocParallel} package for details.}

\item{verbose}{Logical, should progress be printed?}
}
\value{
An updated `SummarizedExperiment` instance. The instance now includes
    a new list of models ("fitDTUModels") in its rowData slot,
    which can be accessed by rowData(object)[["fitDTUModels"]].
}
\description{
Parameter estimation of quasi-binomial models.
}
\examples{
data(sumExp_example, package = "satuRn")
sumExp <- fitDTU(
    object = sumExp_example,
    formula = ~ 0 + group,
    parallel = FALSE,
    BPPARAM = BiocParallel::bpparam(),
    verbose = TRUE
)
}
\author{
Jeroen Gilis
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/satuRn-framework.R
\docType{class}
\name{StatModel-class}
\alias{StatModel-class}
\alias{.StatModel}
\title{The StatModel class for satuRn}
\description{
The `StatModel` class contains a statistical model generated by 
the DTU analysis.

Models are created by the dedicated user-level function `fitDTU()`
or manually, using the `StatModel()` constructor.
In the former case, each quantitative feature is assigned its s
tatistical model and the models are stored as a variable in 
a `DataFrame` object, that in turn will  be stored in the `RowData` slot of 
a `SummarizedExperiment object`.
}
\section{Slots}{

\describe{
\item{\code{type}}{`character(1)` defining type of the used model. Default is
`"fitError"`, i.e. an error model. 
If not an error, class type will be `"glm"`.}

\item{\code{params}}{A `list()` containing the parameters of the fitted model.}

\item{\code{varPosterior}}{`numeric()` of posterior variance.}

\item{\code{dfPosterior}}{`numeric()` of posterior degrees of freedom.}
}}

\examples{
## A fully specified dummy model
myModel <- StatModel(
    type = "glm",
    params = list(x = 3, y = 7, b = 4),
    varPosterior = c(0.1, 0.2, 0.3),
    dfPosterior = c(6, 7, 8)
)
myModel
}
\author{
Jeroen Gilis
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{Tasic_metadata_vignette}
\alias{Tasic_metadata_vignette}
\title{Metadata associated with the expression matrix `Tasic_counts_vignette`. 
See `?Tasic_counts_vignette` for more information on the dataset.}
\format{
An object of class \code{data.frame} with 60 rows and 3 columns.
}
\usage{
data(Tasic_metadata_vignette)
}
\description{
Metadata associated with the expression matrix `Tasic_counts_vignette`. 
See `?Tasic_counts_vignette` for more information on the dataset.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{sumExp_example}
\alias{sumExp_example}
\title{A `SummarizedExperiment` derived from our case study which builds on 
the dataset of Tasic et al. It contains the same cells as the data object 
used in the vignette (see `?Tasic_counts_vignette` for more information). 
In this SummarizedExperiment, we performed a filtering with `filterByExpr` 
of edgeR with more stringent than default parameter settings 
(min.count = 100,min.total.count = 200, large.n = 50, min.prop = 0.9) to 
reduced the number of retained transcripts. We used this object to create 
an executable example in the help files of satuRn.}
\format{
An object of class \code{SummarizedExperiment} with 1286 rows and 60 columns.
}
\usage{
data(sumExp_example)
}
\description{
A `SummarizedExperiment` derived from our case study which builds on 
the dataset of Tasic et al. It contains the same cells as the data object 
used in the vignette (see `?Tasic_counts_vignette` for more information). 
In this SummarizedExperiment, we performed a filtering with `filterByExpr` 
of edgeR with more stringent than default parameter settings 
(min.count = 100,min.total.count = 200, large.n = 50, min.prop = 0.9) to 
reduced the number of retained transcripts. We used this object to create 
an executable example in the help files of satuRn.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{Tasic_counts_vignette}
\alias{Tasic_counts_vignette}
\title{A `Matrix` with transcript-level counts 
derived from our case study which  builds on the dataset of Tasic et al. 
We used Salmon (V1.1.0) to quantify all L5IT cells 
(both for ALM and VISp tissue) from mice with a normal eye condition. 
From these cells, we randomly sampled 20 cells of each of the following 
cell types to use for this vignette;
L5_IT_VISp_Hsd11b1_Endou, L5_IT_ALM_Tmem163_Dmrtb1 and L5_IT_ALM_Tnc. 
The data has already been leniently filtered with 
the `filterByExpr` function of edgeR.}
\format{
An object of class \code{matrix} (inherits from \code{array}) with 22273 rows and 60 columns.
}
\usage{
data(Tasic_counts_vignette)
}
\description{
A `Matrix` with transcript-level counts 
derived from our case study which  builds on the dataset of Tasic et al. 
We used Salmon (V1.1.0) to quantify all L5IT cells 
(both for ALM and VISp tissue) from mice with a normal eye condition. 
From these cells, we randomly sampled 20 cells of each of the following 
cell types to use for this vignette;
L5_IT_VISp_Hsd11b1_Endou, L5_IT_ALM_Tmem163_Dmrtb1 and L5_IT_ALM_Tnc. 
The data has already been leniently filtered with 
the `filterByExpr` function of edgeR.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/accessors.R
\name{getModel,StatModel-method}
\alias{getModel,StatModel-method}
\alias{statModelAccessors}
\alias{getModel}
\alias{getDF}
\alias{getDfPosterior}
\alias{getDispersion}
\alias{getCoef}
\alias{getDF,StatModel-method}
\alias{getDfPosterior,StatModel-method}
\alias{getDispersion,StatModel-method}
\alias{getCoef,StatModel-method}
\title{Accessor functions for StatModel class}
\usage{
\S4method{getModel}{StatModel}(object)

\S4method{getDF}{StatModel}(object)

\S4method{getDfPosterior}{StatModel}(object)

\S4method{getDispersion}{StatModel}(object)

\S4method{getCoef}{StatModel}(object)
}
\arguments{
\item{object}{StatModel object}
}
\value{
The requested parameter of the StatModel object
}
\description{
Accessor functions for StatModel class
    \describe{
        \item{getModel(object)}{to get model}
        \item{getDF(object)}{to get the residual degrees of freedom 
                of the model}
        \item{getDfPosterior(object)}{to get the degrees of freedom of
                the empirical Bayes variance estimator}
        \item{getDispersion(object)}{to get the dispersion estimate of 
                the model}
        \item{getCoef(object)}{to get the parameter estimates of the mean 
                model}
             }
}
\examples{
## A fully specified dummy model
myModel <- StatModel(
    type = "glm",
    params = list(x = 3, y = 7, b = 4),
    varPosterior = c(0.1, 0.2, 0.3),
    dfPosterior = c(6, 7, 8)
)
getModel(myModel)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/satuRn-framework.R
\name{StatModel}
\alias{StatModel}
\title{StatModel}
\usage{
StatModel(
  type = "fitError",
  params = list(),
  varPosterior = NA_real_,
  dfPosterior = NA_real_
)
}
\arguments{
\item{type}{default set to fiterror, can be a glm}

\item{params}{A list containing the parameters of the fitted glm}

\item{varPosterior}{Numeric, posterior variance of the glm, default is NA}

\item{dfPosterior}{Numeric, posterior degrees of freedom of the glm, 
default is NA}
}
\value{
A StatModel object
}
\description{
Function for contstructing a new `StatModel` object.
}
\examples{
## A fully specified dummy model
myModel <- StatModel(
    type = "glm",
    params = list(x = 3, y = 7, b = 4),
    varPosterior = c(0.1, 0.2, 0.3),
    dfPosterior = c(6, 7, 8)
)
myModel
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/testDTU.R
\name{testDTU}
\alias{testDTU}
\title{Test function to obtain a top list of transcripts that are
differentially used in the contrast of interest}
\usage{
testDTU(object, contrasts, diagplot1 = TRUE, diagplot2 = TRUE, sort = FALSE)
}
\arguments{
\item{object}{A `SummarizedExperiment` instance containing a list of objects 
of the `StatModel` class as obtained by the `fitDTU` function of the 
`satuRn` package.}

\item{contrasts}{`numeric` matrix specifying one or more contrasts of 
the linear model coefficients to be tested. The rownames of the matrix 
should be equal to the names of parameters of the model that are 
involved in the contrast. The column names of the matrix will be used 
to construct names to store the results in the rowData of 
the SummarizedExperiment.}

\item{diagplot1}{`boolean(1)` Logical, defaults to TRUE. If set to TRUE,
a plot of the histogram of the z-scores (computed from p-values) is 
displayed using the locfdr function of the `locfdr` package. The blue 
dashed curve is fitted to the mid 50% of the z-scores, which are assumed 
to originate from null transcripts, thus representing the estimated 
empirical null component densities. The maximum likelihood estimates 
(MLE) and central matching estimates  (CME) of this estimated empirical 
null distribution are given below the plot. If the values for delta and
sigma deviate from 0 and 1 respectively, the downstream inference will 
be influenced by the empirical adjustment implemented in satuRn.}

\item{diagplot2}{`boolean(1)` Logical, defaults to TRUE. If set to TRUE,
a plot of the histogram of the "empirically adjusted" test statistics and 
the standard normal distribution will be displayed. Ideally, the majority
(mid portion) of the adjusted test statistics should follow the standard 
normal.}

\item{sort}{`boolean(1)` Logical, defaults to FALSE. If set to TRUE, 
the output of the topTable test function is sorted according to 
the empirical p-values.}
}
\value{
An updated `SummarizedExperiment` that contains the `Dataframes` 
    that display the significance of DTU for each transcript 
    in each contrast of interest.
}
\description{
Function to test for differential transcript usage (DTU)
}
\examples{
data(sumExp_example, package = "satuRn")
library(SummarizedExperiment)
sumExp <- fitDTU(
    object = sumExp_example,
    formula = ~ 0 + group,
    parallel = FALSE,
    BPPARAM = BiocParallel::bpparam(),
    verbose = TRUE
)
group <- as.factor(colData(sumExp)$group)
design <- model.matrix(~ 0 + group)
colnames(design) <- levels(group)
L <- matrix(0, ncol = 2, nrow = ncol(design))
rownames(L) <- colnames(design)
colnames(L) <- c("Contrast1", "Contrast2")
L[c("VISp.L5_IT_VISp_Hsd11b1_Endou", 
    "ALM.L5_IT_ALM_Tnc"), 1] <- c(1, -1)
L[c("VISp.L5_IT_VISp_Hsd11b1_Endou", 
    "ALM.L5_IT_ALM_Tmem163_Dmrtb1"), 2] <- c(1, -1)

sumExp <- testDTU(object = sumExp, 
    contrasts = L, 
    diagplot1 = FALSE,
    diagplot2 = FALSE,
    sort = FALSE)
}
\author{
Jeroen Gilis
}
